	/* Returns current directory and, for MS OSes, current drive */
	void		V_GLOBAL	fsGetDir(char *dest_path);
	/* Creates one ore more directories (may be on different drive) */
	vboolean	V_GLOBAL	fsCreateDir(char *dirs);
	/* Changes current directory/ies (dirs can point to another drive) */
	vboolean	V_GLOBAL	fsChangeDir(char *dirs);

#ifndef	__UNIX__

char V_LOCAL
fsGetDrive(void)
{
#if		defined(__DOS32__) && defined(__WATCOMC__)
    unsigned drive;
    _dos_getdrive(&drive);
    return (char)(drive-1+'a');
#else	/* defined(__DOS32__) && defined(__WATCOMC__) */
    return (char)(_getdrive()-1+'a');
#endif	/* defined(__DOS32__) && defined(__WATCOMC__) */
}

vboolean	V_LOCAL
fsSetDrive(char drive_letter)
{
	if(isupper(drive_letter))
		tolower(drive_letter);
#if		defined(__DOS32__) && defined(__WATCOMC__)
    unsigned drive, total;
    _dos_setdrive(drive_letter-'a'+1,&total);
    _dos_getdrive(&drive);
	if((drive-1+'a')==drive_letter)
		return true;
	else
		return false;
#else	/* defined(__DOS32__) && defined(__WATCOMC__) */
	if(_chdrive(drive_letter-'a'+1)==0)
		return true;
	else
		return false;
#endif	/* defined(__DOS32__) && defined(__WATCOMC__) */
}

#endif	/* __UNIX__ */

/*
 *	Creates one ore more directories
 */
vboolean	V_GLOBAL
fsCreateDir(char *dirs)
{
	char dir[_MAX_DIR+1], *ptr;
	int retval;
#ifndef	__UNIX__
	char drive_letter='*';
#endif	/* __UNIX__ */
	if(!dirs)
    {
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,
			"fsCreatePath('%s'): incorrect parameter.\n",dbs(dirs));
#endif	/* CHECKED_BUILD */
		return false;
	}
#ifndef	__UNIX__
	if(dirs[0]=='/' && dirs[1]=='/' && dirs[3]=='/')
	{
		/* Change drive */
		drive_letter=fsGetDrive();
		if(!fsSetDrive(dirs[2]))
			return false;
	}
#endif	/* __UNIX__ */
	/* split dirs */
	retval=true;
	while(*dirs)
	{
		/* copy next dir into 'dir' */
		for(ptr=dir;;ptr++)
		{
			*ptr=*dirs;
			dirs++;
			if(*ptr=='/')
				break;
		}
		ptr[1]=0;
		/* if dir!='/' strip trail shash */
		if(dir[0]!='/' || dir[1]!=0)
			*ptr=0;
		else /* ignore trail slash */
			if(*dirs==0)
				break;
		/* change dir */
		retval=_chdir(dir) ? false : true;
		if(!retval)
		{
			/* create dir */
			retval=_mkdir(dir) ? false : true;
			if(!retval)
				break;
			retval=_chdir(dir) ? false : true;
			if(!retval)
				break;
		}
	}
#ifndef	__UNIX__
	if(drive_letter!='*')
		fsSetDrive(drive_letter);
#endif
	return retval;
}
	
/*
 *	Changes current directory (dirs can point to another drive)
 */
vboolean	V_GLOBAL
fsChangeDir(char *dirs)
{
	char dir[_MAX_DIR+1], *ptr;
	int retval;
#ifndef	__UNIX__
	char drive_letter='*';
#endif	/* __UNIX__ */
	if(!dirs)
    {
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,
			"fsChangeDir('%s'): incorrect parameter.\n",dbs(dirs));
#endif	/* CHECKED_BUILD */
		return false;
	}
#ifndef	__UNIX__
	if(dirs[0]=='/' && dirs[1]=='/' && dirs[3]=='/')
	{
		/* Change drive */
		drive_letter=fsGetDrive();
		if(!fsSetDrive(dirs[2]))
			return false;
	}
#endif	/* __UNIX__ */
	/* split dirs */
	retval=true;
	while(*dirs)
	{
		/* copy next dir into 'dir' */
		for(ptr=dir;;ptr++)
		{
			*ptr=*dirs;
			dirs++;
			if(*ptr=='/')
				break;
		}
		ptr[1]=0;
		/* if dir!='/' strip trail shash */
		if(dir[0]!='/' || dir[1]!=0)
			*ptr=0;
		else /* ignore trail slash */
			if(*dirs==0)
				break;
		/* change dir */
		retval=_chdir(dir)==0;
		if(!retval)
			break;
	}
#ifndef	__UNIX__
	if(drive_letter!='*')
		fsSetDrive(drive_letter);
#endif
	return retval;
}

