/*
 *	Computes value which is nearest to given 'ref', contains 'num_digits'
 *	of significant digits and with even least significant digit.
 */
vec_t	V_LOCAL
make_readable_float(vec_t ref,u32_t num_digits)
{
	vec_t md,s,mult,v31,v32;
	if(num_digits<1)
	  	num_digits=1;
	if(ref>=0)
		s=1;
	else
		s=-1;
	mult=(vec_t)pow(10,floor(log10(Range*s)));
	md=(vec_t)pow(10,Digits-1);
	v31=Range*s*md/mult;
	v32=(vec_t)ceil(v31);
	v31=(vec_t)floor(v31);
	if(!IsZero(fmod(v31,2)))
		v31=v32;
	return	s*v31*mult/md;
}

void	V_LOCAL
compute_linear_transform(vec2_t transform,vec2_t in_range,vec2_t out_range)
{
	vec_t in_len=in_range[1]-in_range[0];
	vec_t out_len=out_range[1]-out_range[0];
	if(IsZero(in_len))
		vec2Set(transform,1,0);
	else
	{
		transform[0]=out_len;
		transform[1]=in_range[0]*out_range[1]-in_range[1]*out_range[0];
		vec2Scale(transform,1/in_len);
	}
}

