program Eitk;

uses Crt,Graph;

type
  vec_t   = double;
  array_t = array[0..255] of vec_t;
  array_p = ^array_t;

{====================================================================}
{                     }
{====================================================================}

function eitkenn(var x:array_t;y:array_t;n:integer;xc:vec_t):vec_t;
label
  l1, l2,l3;
var
  i,j : integer;
begin
  j:=1;
l1:
  i:=0;
l2:
  y[i]:=(y[i]*(x[i+j]-xc)-y[i+1]*(x[i]-xc))/(x[i+j]-x[i]);
  i:=i+1;
  if i<>n then goto l2;
  n:=n-1;
  if n=0 then goto l3;
  j:=j+1;
  goto l1;
l3:
  eitkenn:=y[0];
end;

{====================================================================}
{                                               }
{====================================================================}

var
  n   : integer;
  x,y : array_t;

{====================================================================}
{                             }
{====================================================================}

procedure fill_arrays;
var
  i : integer;
begin
  write('   (3-255): ');
  readln(n);
  writeln;
  n:=n-1;
  for i:=0 to n do begin
    writeln('   :',i+1);
    write('x = ');
    readln(x[i]);
    write('y = ');
    readln(y[i]);
  end;
end;

{====================================================================}
{                 }
{====================================================================}

function real_str(v:vec_t):string;
var
  s:string[64];
begin
  Str(v:3:1,s);
  real_str:=s;
end;

{====================================================================}
{                       }
{====================================================================}

var
  offset,scale,grid : array[0..1] of double;
  
procedure draw_graph;
const
  sx = 640;
  sy = 480;
  border = 30;
var
  i             : integer;
  xx,xm,yx,ym   : vec_t;
  scalex,scaley : vec_t;
  ofsx,ofsy     : vec_t;
  ix, iy        : integer;
  step          : vec_t;
  istep         : integer;
  xt,xp,yt,yp   : vec_t;
begin
  ClearDevice;
  SetBkColor(15);
  SetColor(8);
  ClearDevice;
  SetLineStyle(SolidLn,0,ThickWidth);
  Rectangle(border-2,border-2,sx-border+1,sy-border+1);
  xx:=x[0];xm:=x[0];
  yx:=y[0];ym:=y[0];
  for i:=1 to n do begin
    if xx < x[i] then xx := x[i] else if xm > x[i] then xm := x[i];
    if yx < y[i] then yx := y[i] else if ym > y[i] then ym := y[i];
  end;
  scalex:=(sx-2*border)/(xx-xm);
  scaley:=(sy-2*border)/(ym-yx);
  ofsx:=offset[0]+border-scalex*xm;
  ofsy:=offset[1]+border-scaley*yx;
  scalex:=scale[0]*scalex;
  scaley:=scale[1]*scaley;
  Line(round(ofsx),border-2,round(ofsx),sy-border-1);
  Line(border-2,round(ofsy),sx-border-1,round(ofsy));
  SetLineStyle(SolidLn,0,NormWidth);
  step:=1000000;
  while(step > (xx-xm)) do step:=step/10;
  step:=step*grid[0];
  istep:=round(step*scalex);
  ix:=round(ofsx);iy:=ix;
  ix:=ix+istep;
  while(ix<(sx-border-2)) do begin
    Line(ix,border-2,ix,sy-border-1);
    OutTextXY(ix+4,round(ofsy)+4,real_str((ix-ofsx)/scalex));
    ix:=ix+istep;
  end;
  ix:=iy-istep;
  while(ix>(border-2)) do begin
    Line(ix,border-2,ix,sy-border-1);
    OutTextXY(ix+4,round(ofsy)+4,real_str((ix-ofsx)/scalex));
    ix:=ix-istep;
  end;
  step:=1000000;
  while(step > (yx-ym)) do step:=step/10;
  step:=step*grid[1];
  istep:=round(step*scaley);
  iy:=round(ofsy);
  ix:=iy;
  iy:=iy+istep;
  while(iy<(sy-border-2)) do begin
    Line(border-2,iy,sx-border-1,iy);
    OutTextXY(round(ofsx)+4,iy+4,real_str((iy-ofsy)/scaley));
    iy:=iy+istep;
  end;
  iy:=ix-istep;
  while(iy>(border-2)) do begin
    Line(border-2,iy,sx-border-1,iy);
    OutTextXY(round(ofsx)+4,iy+4,real_str((iy-ofsy)/scaley));
    iy:=iy-istep;
  end;
  OutTextXY(round(ofsx)+4,round(ofsy)+4,'0');
  yp:=eitkenn(x,y,n,(border-ofsx)/scalex);
  SetLineStyle(SolidLn,0,ThickWidth);
  for ix:=border+1 to sx-border-1 do begin
    xt:=(ix-ofsx)/scalex;
    yt:=eitkenn(x,y,n,xt);
    Line(ix-1,round(yp*scaley+ofsy),ix,round(yt*scaley+ofsy));
    yp:=yt;
  end;
  SetLineStyle(SolidLn,0,NormWidth);
  for i:=0 to n do begin
    ix:=round(x[i]*scalex+ofsx);
    iy:=round(y[i]*scaley+ofsy);
    if(i<>n) then
      Line(ix,iy,round(x[i+1]*scalex+ofsx),round(y[i+1]*scaley+ofsy));
    Bar(ix-3,iy-3,ix+3,iy+3);
    Rectangle(ix-3,iy-3,ix+3,iy+3);
  end;
end;

{====================================================================}
{                                                   }
{====================================================================}

var
  key,drv,mode  : integer;
  ch            : char;
  redraw        : boolean;
  
begin
  fill_arrays;
  drv:=VGA;
  mode:=VGAHI;
  InitGraph(drv,mode,'.');
  offset[0]:=0.0;
  offset[1]:=0.0;
  scale[0]:=1.0;
  scale[1]:=1.0;
  grid[0]:=1.0;
  grid[1]:=1.0;
  draw_graph;
  while keypressed do ch:=readkey;
  while true do begin
    redraw:=true;
    key:=ord(readkey);
    case key of
      0:
      begin
        key:=ord(readkey);
        case key of
          72: { Up }
            offset[1]:=offset[1]-5.0;
          80: { Down }
            offset[1]:=offset[1]+5.0;
          75: { Left }
            offset[0]:=offset[0]-5.0;
          77: { Right }
            offset[0]:=offset[0]+5.0;
          else; redraw:=false;
        end;
      end;
      45: { - }
      begin
        scale[0]:=scale[0]/1.1;
        scale[1]:=scale[1]/1.1;
      end;
      43,61: { + }
      begin
        scale[0]:=scale[0]*1.1;
        scale[1]:=scale[1]*1.1;
      end;
      97:  { a }
      begin
        grid[0]:=grid[0]*2;
        grid[1]:=grid[1]*2;
      end;
      122: { z }
      begin
        grid[0]:=grid[0]*0.5;
        grid[1]:=grid[1]*0.5;
      end;
      27:
      begin
        CloseGraph;
        exit;
      end;
      else; redraw:=false;
    end;
    if redraw then draw_graph;
  end;
end.
