#ifndef       UGL_H
#define       UGL_H

#define       bool  int
#include      <windows.h>
#include      <gl\gl.h>
#pragma       hdrstop

#include      "..\u_typedef.h"

/*=======================================================================
*                       OpenGL.
* :       ugl.h
* :     1.0 (10.07.99)
* : Misrosoft C  Watcom C.
* :  Win32 (9x & NT)
* :         OpenGL.
* :       ..
* :
* 10.07.99 -  .
* =======================================================================
* .
*  1.  .
*           OpenGL. ,
* -  3dfx Voodoo    , 
*  Riva-128      ..  -
*       .   
*  OpenGL   ,   Quake:             */

typedef WINGDIAPI void (APIENTRY *pglAlphaFunc)(GLenum func, GLclampf ref);
typedef WINGDIAPI void (APIENTRY *pglBegin)(GLenum mode);
typedef WINGDIAPI void (APIENTRY *pglBlendFunc)
        (GLenum sfactor, GLenum dfactor);
typedef WINGDIAPI void (APIENTRY *pglClear)(GLbitfield mask);
typedef WINGDIAPI void (APIENTRY *pglClearColor)
        (GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha);
typedef WINGDIAPI void (APIENTRY *pglColor3f)
        (GLfloat red, GLfloat green, GLfloat blue);
typedef WINGDIAPI void (APIENTRY *pglColor3ubv)(const GLubyte *v);
typedef WINGDIAPI void (APIENTRY *pglColor4f)
        (GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha);
typedef WINGDIAPI void (APIENTRY *pglColor4ubv)(const GLubyte *v);
typedef WINGDIAPI void (APIENTRY *pglCullFace)(GLenum mode);
typedef WINGDIAPI void (APIENTRY *pglDepthFunc)(GLenum func);
typedef WINGDIAPI void (APIENTRY *pglDepthMask)(GLboolean flag);
typedef WINGDIAPI void (APIENTRY *pglDepthRange)
        (GLclampd zNear, GLclampd zFar);
typedef WINGDIAPI void (APIENTRY *pglDisable)(GLenum cap);
typedef WINGDIAPI void (APIENTRY *pglDrawBuffer)(GLenum mode);
typedef WINGDIAPI void (APIENTRY *pglEnable)(GLenum cap);
typedef WINGDIAPI void (APIENTRY *pglEnd)(void);
typedef WINGDIAPI void (APIENTRY *pglFinish)(void);
typedef WINGDIAPI void (APIENTRY *pglFrustum)(GLdouble left, GLdouble right, 
        GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar);
typedef WINGDIAPI void (APIENTRY *pglGetFloatv)
        (GLenum pname, GLfloat *params);
typedef WINGDIAPI const GLubyte * (APIENTRY *pglGetString)(GLenum name);
typedef WINGDIAPI void (APIENTRY *pglHint)(GLenum target, GLenum mode);
typedef WINGDIAPI void (APIENTRY *pglLoadIdentity)(void);
typedef WINGDIAPI void (APIENTRY *pglLoadMatrixf)(const GLfloat *m);
typedef WINGDIAPI void (APIENTRY *pglMatrixMode)(GLenum mode);
typedef WINGDIAPI void (APIENTRY *pglOrtho)(GLdouble left, GLdouble right, 
        GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar);
typedef WINGDIAPI void (APIENTRY *pglPolygonMode)(GLenum face, GLenum mode);
typedef WINGDIAPI void (APIENTRY *pglPopMatrix)(void);
typedef WINGDIAPI void (APIENTRY *pglPushMatrix)(void);
typedef WINGDIAPI void (APIENTRY *pglReadBuffer)(GLenum mode);
typedef WINGDIAPI void (APIENTRY *pglReadPixels)(GLint x, GLint y, 
  GLsizei width, GLsizei height, GLenum format, GLenum type, GLvoid *pixels);
typedef WINGDIAPI void (APIENTRY *pglRotatef)
        (GLfloat angle, GLfloat x, GLfloat y, GLfloat z);
typedef WINGDIAPI void (APIENTRY *pglScalef)
        (GLfloat x, GLfloat y, GLfloat z);
typedef WINGDIAPI void (APIENTRY *pglShadeModel)(GLenum mode);
typedef WINGDIAPI void (APIENTRY *pglTexCoord2f)(GLfloat s, GLfloat t);
typedef WINGDIAPI void (APIENTRY *pglTexEnvf)
        (GLenum target, GLenum pname, GLfloat param);
typedef WINGDIAPI void (APIENTRY *pglTexImage2D)(GLenum target, 
        GLint level, GLint internalformat, GLsizei width, GLsizei height, 
        GLint border, GLenum format, GLenum type, const GLvoid *pixels);
typedef WINGDIAPI void (APIENTRY *pglTexParameterf)
        (GLenum target, GLenum pname, GLfloat param);
typedef WINGDIAPI void (APIENTRY *pglTranslatef)
        (GLfloat x, GLfloat y, GLfloat z);
typedef WINGDIAPI void (APIENTRY *pglVertex2f)(GLfloat x, GLfloat y);
typedef WINGDIAPI void (APIENTRY *pglVertex3f)
        (GLfloat x, GLfloat y, GLfloat z);
typedef WINGDIAPI void (APIENTRY *pglVertex3fv)(const GLfloat *v);
typedef WINGDIAPI void (APIENTRY *pglViewport)
        (GLint x, GLint y, GLsizei width, GLsizei height);
/*   P5-233  Voodoo1 -  Quake   25 /; 
    Klamath-233  Riva-128 ICD -   Quake   50 /. 
          . 
            (Riva-128  
    ,  3dfx -   _grFogXXX)  
      (glXXXPointer).  ,    
     - glBindTexture -      
          32- . , ,
       Quake    (    - ?).
      :)
*/
/*    -    */
typedef WINGDIAPI void (APIENTRY *pglFogf)(GLenum pname, GLfloat param);
typedef WINGDIAPI void (APIENTRY *pglFogfv)
        (GLenum pname, const GLfloat *params);
typedef WINGDIAPI void (APIENTRY *pglFogi)(GLenum pname, GLint param);
typedef WINGDIAPI void (APIENTRY *pglFogiv)
        (GLenum pname, const GLint *params);
/*    -    */
typedef WINGDIAPI void (APIENTRY *pglGenTextures)
        (GLsizei n, GLuint *textures);
typedef WINGDIAPI void (APIENTRY *pglBindTexture)
        (GLenum target, GLuint texture);
typedef WINGDIAPI void (APIENTRY *pglDeleteTextures)
        (GLsizei n, const GLuint *textures);
/*    -     */
typedef WINGDIAPI void (APIENTRY *pglEnableClientState)(GLenum array);
typedef WINGDIAPI void (APIENTRY *pglDisableClientState)(GLenum array);
typedef WINGDIAPI void (APIENTRY *pglDrawArrays)
        (GLenum mode, GLint first, GLsizei count);
typedef WINGDIAPI void (APIENTRY *pglColorPointer)
        (GLint size, GLenum type, GLsizei stride, const GLvoid *pointer);
typedef WINGDIAPI void (APIENTRY *pglTexCoordPointer)
        (GLint size, GLenum type, GLsizei stride, const GLvoid *pointer);
typedef WINGDIAPI void (APIENTRY *pglVertexPointer)
        (GLint size, GLenum type, GLsizei stride, const GLvoid *pointer);
/*   -  ,   z- */
typedef WINGDIAPI void (APIENTRY *pglClearDepth)(GLclampd depth);

/*
==================================
    GLIMLayerType
==================================
*/

typedef enum 
{ 
  GenericLayer,
} GLIMLayerType;

/*
==================================
    GLRenderType
==================================
*/

typedef enum
{
  Software,
  ICD,
  MCD
} GLRenderType;

/*
==================================
    GLIMLayer
==================================
*/

typedef struct        GLIMLayer_s
{
  //   -  
  pglAlphaFunc        AlphaFunc;
  pglBegin            Begin;
  pglBlendFunc        BlendFunc;
  pglClear            Clear;
  pglClearColor       ClearColor;
  pglColor3f          Color3f;
  pglColor3ubv        Color3ubv;
  pglColor4f          Color4f;
  pglColor4ubv        Color4ubv;
  pglCullFace         CullFace;
  pglDepthFunc        DepthFunc;
  pglDepthMask        DepthMask;
  pglDepthRange       DepthRange;
  pglDisable          Disable;
  pglDrawBuffer       DrawBuffer;
  pglEnable           Enable;
  pglEnd              End;
  pglFinish           Finish;
  pglFrustum          Frustum;
  pglGetFloatv        GetFloatv;
  pglGetString        GetString;
  pglHint             Hint;
  pglLoadIdentity     LoadIdentity;
  pglLoadMatrixf      LoadMatrixf;
  pglMatrixMode       MatrixMode;
  pglOrtho            Ortho;
  pglPolygonMode      PolygonMode;
  pglPopMatrix        PopMatrix;
  pglPushMatrix       PushMatrix;
  pglReadBuffer       ReadBuffer;
  pglReadPixels       ReadPixels;
  pglRotatef          Rotatef;
  pglScalef           Scalef;
  pglShadeModel       ShadeModel;
  pglTexCoord2f       TexCoord2f;
  pglTexEnvf          TexEnvf;
  pglTexImage2D       TexImage2D;
  pglTexParameterf    TexParameterf;
  pglTranslatef       Translatef;
  pglVertex2f         Vertex2f;
  pglVertex3f         Vertex3f;
  pglVertex3fv        Vertex3fv;
  pglViewport         Viewport;
  //   - 
  pglFogf             Fogf;
  pglFogfv            Fogfv;
  pglFogi             Fogi;
  pglFogiv            Fogiv;
  pglGenTextures      GenTextures;
  pglBindTexture      BindTexture;
  pglDeleteTextures   DeleteTextures;
  pglEnableClientState  EnableClientState;
  pglDisableClientState DisableClientState;
  pglDrawArrays       DrawArrays;
  pglColorPointer     ColorPointer;
  pglTexCoordPointer  TexCoordPointer;
  pglVertexPointer    VertexPointer;
  pglClearDepth       ClearDepth;
  //                   
  GLIMLayerType       LayerType;
  GLRenderType        RenderType;
  HINSTANCE           hRenderer;
  HINSTANCE           hGDI;
  HPALETTE            ghPalette, ghpalOld;
  BOOL                (APIENTRY *pSwapBuffers)(HDC);
  HDC                 (APIENTRY *pwglGetCurrentDC)(void);
  int                 (APIENTRY *pChoosePixelFormat)(HDC, CONST PIXELFORMATDESCRIPTOR *);
  BOOL                (APIENTRY *pSetPixelFormat)(HDC, int, CONST PIXELFORMATDESCRIPTOR *);
  int                 (APIENTRY *pDescribePixelFormat)(HDC,int,UINT,LPPIXELFORMATDESCRIPTOR);
  int                 (APIENTRY *pGetPixelFormat)(HDC);
  HGLRC               (APIENTRY *pwglCreateContext)(HDC);
  BOOL                (APIENTRY *pwglDeleteContext)(HGLRC);
  HGLRC               (APIENTRY *pwglGetCurrentContext)(void);
  PROC                (APIENTRY *pwglGetProcAddress)(LPCSTR);
  BOOL                (APIENTRY *pwglMakeCurrent)(HDC, HGLRC);
} GLIMLayer;

typedef GLIMLayer *PGLIMLayer;  // BUG BUG BUG in MS VC 5.0 !!!!!!!!!!!!!!!!

extern PGLIMLayer UEXPORT LoadGenericRenderer(char *dllName,HWND hWnd);
extern void UEXPORT DestroyLayer(GLIMLayer *Layer);

#endif
