#include 	<windows.h>
#include 	<gl\gl.h>
#include 	<gl\glaux.h>
#pragma 	hdrstop
#include  <float.h>
#include  <math.h>

#ifndef		U_TYPEDEF
typedef		GLfloat vec_t;
typedef	  vec_t vec2_t[2];
typedef		vec_t vec3_t[3];

#ifndef		M_PI
#define   M_PI 3.14159265357989
#endif

typedef		struct
{
  unsigned char rgba[4];
  vec3_t v;
} tlvert_t;

typedef		struct
{
  unsigned char rgba[4];
  vec2_t	t;
  vec3_t 	v;
} tlvertex_t;

#endif

tlvert_t cv[24 + 2];

void initialize()
{
  int i,j;
  float R,a,x,y,r,g,b;
  R=0.8;
  a=0;
  memset(cv,0,sizeof(tlvert_t));
  for(i=1;i<25;i++)
  {
    x=R*cos(a);
    y=R*sin(a);
    for(j=0;j<4;j++) cv[i].rgba[j]=rand()%255;
    cv[i].v[0]=x;
    cv[i].v[1]=y;
    cv[i].v[2]=0;
    a+=M_PI/12;
  }
  memcpy(&cv[i],&cv[1],sizeof(tlvert_t));
}

#define VERT_ARRAY

#ifndef VERT_ARRAY

void circle()
{
  int i;
  glBegin(GL_TRIANGLE_FAN);
  for(i=0;i<26;i++)
  {
    glColor3ubv(cv[i].rgba);
    glVertex3fv(cv[i].v);
  }
  glEnd();
}

#else

void circle()
{
  glColorPointer(4,GL_UNSIGNED_BYTE,sizeof(tlvert_t),&cv[0].rgba[0]);
  glVertexPointer(3,GL_FLOAT,sizeof(tlvert_t),&cv[0].v[0]);
  glEnableClientState(GL_COLOR_ARRAY);
  glEnableClientState(GL_VERTEX_ARRAY);
  glDrawArrays(GL_TRIANGLE_FAN,0,26);
}

#endif

void circles()
{
  circle();
  glPushMatrix();
  glRotatef(90,0,1,0);
  circle();
  glPopMatrix();
  glRotatef(90,1,0,0);
  circle();
}

float alpha = 0, betta = 0;

void drawscene(int milliseconds)
{
  glEnable(GL_DEPTH_TEST);
  glShadeModel(GL_SMOOTH);
  glRotatef(alpha,1,0,0);
  glRotatef(betta,0,0,1);
  circles();

  alpha += (float)milliseconds / 20;
  betta += (float)milliseconds / 40;
}

void CALLBACK Resize(GLsizei width, GLsizei height )
{
  GLfloat aspect;
  if(!width || !height) return;
  aspect=width/height;
  glViewport(0,0,width,height);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glOrtho(-aspect,aspect,-1,1,-1,1);
  glMatrixMode(GL_MODELVIEW);
}    

int PrevTick;

void CALLBACK Draw()
{
  int Tick;
  auxSwapBuffers();
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  Tick=GetTickCount();
  glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
  drawscene(Tick - PrevTick);
  PrevTick=Tick;
  glFlush();
}

#define WIN_SIZEX 640
#define WIN_SIZEY 480

void main()
{
  _control87(0x133,0xffffffff);
  initialize();
  auxInitPosition(20,20,WIN_SIZEX,WIN_SIZEY);
  auxInitDisplayMode(AUX_RGB|AUX_DOUBLE);
  if(!auxInitWindow("GLaux template")) auxQuit();
  auxReshapeFunc(Resize);
  SetClassLong(GetForegroundWindow(),GCL_HBRBACKGROUND,0);
  PrevTick=GetTickCount();
  auxIdleFunc(Draw);
  Resize(WIN_SIZEX,WIN_SIZEY);
  auxMainLoop(Draw);
}
