#pragma pack(1);
typedef struct
{
  unsigned byte rgba[4];
  struct { float x,y; } v;
} c4ub_v2f_t;

typedef struct
{
  unsigned byte rgba[4];
  struct { float x,y,z; } v;
} c4ub_v3f_t;

typedef struct
{
  struct { float u,v; } t;
  struct { unsigned byte r,g,b,a ; } rgba;
  struct { float x,y,z; } n;
  struct { float x,y,z; } v;
} vertex_t;
#pragma pack();

#define MAX_POLY_VERTICES	16

typedef struct
{
  int numvertices;
  vertex_t vertices[1];
} vertexlist_t;

typedef struct
{
  int numvertices;
  int vertices[3];
} triangle_t;

typedef struct
{
  int numfaces;
  triangle_t faces[1];
} facelist_t;

typedef struct
{
  vertexlist_t *vlist;
  facelist_t *flist;
} texturedmesh_t;

typedef enum
{
  // shading
  shademodel,
  wireframe,
  flat,
  gouraud,
  
  // z-buffering
  ztest,
  zenable,
  zdisable,

  // alpha-chromakeying
  alphatest,
  alphaenable,
  alphadisable,
  
  // color blending
  blendfunc,
  blendnone,
  blendoneone,
  blendonesrccolor,
  
  // texturing
  texture,
  texenable,
  texdisable,
  
  texmagfilter,
  texmagnearest,
  texmaglinear,
  
  texminfilter,
  texminnearest,
  texminlinear,
  
  texcombine,
  texcombinenone,
  texcombinemodulate,
  
  // vertex layout
  vertexlayout,
  vertexc3ubv3f,
  vertext2fc3ubv3f
  
  
} urenderstate_t;


typedef struct
{
  bool Init(void);
  bool WinEventProc(int ename,void *entry);
  bool WinOpen(int width,int height,int bpp,int refreshrate);
  bool WinClose(void);
  bool ShutDown(void);
  
  //       3D-API.   
  //   .
  void SetRenderState(int pname,int param);
  void SetModelviewMatrix(void *matrix);
  void SetProjectionMatrix(void *matrix);
  void DownloadMipmaps(int width,int height,int nummiplevels,int count,
    rgba_t *data,texhandle *handles);
  void ReleaseMipmaps(int count,texhandle *mipmaps);
  void DrawVertexList(int count,void *data);
  void CaptureFrameBuffer(void *dest);
  
  
}

