#include "lbmlib.h"

typedef struct teximages_s
{
  int   numtex;
  int   curtex;
  int   *glnames;
  char  **texnames; // remove ?
} teximages_t;

u3dbool teximages_init(teximages_t *teximages,int num_tex)
{
  int i;
  ASSERT(teximages);
  if(num_tex)
  {
    init_teximages(teximages,0);
    teximages->numtex=num_tex;
    teximages->curtex=0;
    teximages->glnames=(int*)malloc(num_tex*sizeof(int));
    if(!teximages->glnames) 
      return u3d_false;
    teximages->texnames=(char**)malloc(num_tex*sizeof(char*));
    if(!teximages->texnames)
    {
      clean_teximages(teximages);
      return u3d_false;
    }
    for(i=0;i<num_tex;i++)
    {
      teximages->texnames[i]=(char*)malloc(MAX_TEXNAME*sizeof(char));
      if(!teximages->texnames[i])
      {
        clean_teximages(teximages);
        return u3d_false;
      }
    }
    return u3dtrue;
  }
  else
  {
    teximages->numtex=teximages->curtex=0;
    teximages->glnames=NULL;
    teximages->texnames=NULL;
    return u3dtrue;
  }
}

void teximages_clean(teximages_t *teximages)
{
  int i;
  ASSERT(teximages);
  if(teximages->glnames)
  {
    for(i=0;i<teximages->numtex;i++)
      if(teximages->glnames[i])
        glDeleteTextures(1,teximages->glnames+i);
    free(teximages->glnames);
  }
  if(teximages->texnames)
  {
    for(i=0;i<teximages->numtex;i++)
      if(teximages->texnames[i])
        free(teximages->texnames[i]);
    free(teximages->texnames);
  }
  teximages->glnames=NULL;
  teximages->texnames=NULL;
  teximages->numtex=0;
  teximages->curtex=0;
}

u3dbool teximages_add(teximages_t *teximages,char *name)
{
  return u3dfalse;
}

u3bool teximages_bind(teximages_t *teximages,int num)
{
  ASSERT((num<teximages->numtex)&&(teximages->glnames[num]!=0));
  glBindTexture(GL_TEXTURE_2D,teximages->glnames[num]);
  return u3dtrue;
}
