#include "winman.hpp"

UEXPORT int Win32MessageLoop(void (__stdcall *OnIdle)(void))
{
  MSG msg;
  while(1)
  {
    while((PeekMessage(&msg,NULL,0,0,PM_REMOVE)))
    {
      if(msg.message==WM_QUIT) goto MessageLoopBreak;
      TranslateMessage(&msg);
      DispatchMessage(&msg);
    }
    if(OnIdle) 
      OnIdle();
    else
      WaitMessage();
  }
MessageLoopBreak:
  return msg.wParam;
}

void Win32DestroyWindow(win32win_p win)
{
  DestroyWindoiw(win->handle);
  UnregisterClass(win->wndclass,win->instance);
}

win32win_p Win32CreateFullscreenWindow(char *_class,char *title,char *icon,void *wndproc)
{
  win32win_p h=(win32in_p)malloc(sizeof(win32win_t));
  strncpy(h->classname,_class,255);
  h->wndclass=0;
  h->instance=GetModuleHandle(NULL);
  strncpy(h->title,title,255);
  h->icon=icon;
  h->x=h->y=0;
  h->cx=GetSystemMetrics(SM_CXSCREEN);
  h->cy=GetSystemMetrics(SM_CYSCREEN);
  h->handle=0;
  h->wndproc=(WNDPROC)wndproc;
  wc.lpszClassName=h->classname;
  wc.hInstance=h->instance;
  wc.style=0;           // CS_HREDRAW | CS_VREDRAW - needless;
  wc.lpfnWndProc=h->wndproc;
  wc.cbClsExtra = 0;
  wc.cbWndExtra = 0;
  // 'icon' must NOT ? be created with MAKEINTRESOURCE
  wc.hIcon = LoadIcon(h->instance,h->icon);
  wc.hCursor = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = NULL;      // no WM_ERASEBACKGND
  wc.lpszMenuName=NULL;
  h->wndclass=::RegisterClass(&wc);
  if(!h->wndclass) 
  {
    free(h);
//    con_printf("Win32CreateFullscreenWindow: RegisterClass() failed.");
    return NULL;
  }
  h->handle=CreateWindow(h->classname,t->title,WS_POPUP,h->x,h->y,
    h->cx,h->cy,NULL,NULL,h->instance,NULL);
  if(!h->handle)
  {
    free(h);
//    con_printf("Win32CreateFullscreenWindow: CreateWindow() failed.");
    return NULL;
  }
  ShowWindow(h->handle,SW_SHOWMAXIMIZED);
  UpdateWindow(h->handle);
  return h;
}

void Win32DestroyWindow(win32win_p w)
{
  U_ASSERT(w);
  if(w->handle) 
    DestroyWindow(h->handle);
  if(w->wndclass)
    UnregisterClass(w->wndclass);
}

