#ifndef                 WINPLUS_H_INCLUDED
#define                 WINPLUS_H_INCLUDED

#ifndef                 _WINDOWS_
#include                <windows.h>
#endif
#include                <stdlib.h>
#include                <math.h>

// =======================================================================
//        'MemOverride'
#define                 MEM_OVERRIDE
// =======================================================================
//    DWORD CWindowBase::OverrideDefaults(int Default);
#define OD_TITLE        0       //   
#define OD_STYLE        1       //   
#define OD_X            2       //  p  p 
#define OD_Y            3
#define OD_WIDTH        4       //  p  
#define OD_HEIGHT       5
#define OD_HICON        6       //  
#define OD_HACCEL       7       //   pp
#define OD_HBRUSH       8       //   
#define OD_HMENU        9       //  
#define OD_HCURSOR      10      //  pp
#define OD_HPARENTWND   11      //   
#define OD_CLASSNAME    12      //    
#define OD_LASTCWB      20
#define OD_DEFAULT      ((DWORD)0xFFFFFFFF)
// =======================================================================
//    p    p p
#define MAX_POPUP_ITEM  32
// =======================================================================
//  p  
#define   FA_PREREAD    1
#define   FA_WRAP       2
//     - 4 
#define         OBF_CASHESIZE           4096
//      - 32 
#define         OBF_MAXCASHESIZE        16*1024*1024
// =======================================================================
//     
#ifndef M_PI
#define M_PI (3.14159265358979323846)
#endif
#ifndef RADinDEG
#define RADinDEG (2*M_PI/180)
#endif
#ifndef MAXDOUBLE
#define MAXDOUBLE       1.797693E+308
#endif
#ifndef MINDOUBLE
#define MINDOUBLE       2.225074E-308
#endif
//    CGraphicalSamples::BeginPath / DrawArrays
// 
#define GS_POINTS           1
//    
#define GS_LINES            2
//  
#define GS_LINESTRIP        3
//  
#define GS_BARS             5
//    
#define GS_BARSTRIP         6
//  
#define GS_VLINES           7
//   CGraphicalSamples::fuDefinedArrays
#define GS_NONE             0
#define GS_COORD_ARRAY      (1<<0)
#define GS_COLOR_ARRAY      (1<<1)
#define GS_BOTH             (GS_COLOR_ARRAY|GS_COORD_ARRAY)
//   CGraphicalSamples::ScaleFromArrays  
// CGraphicalSamples::TranstaleFromArrays
  //    ,   
  //    
#define GS_AUTOSCALE        0
#define GS_AUTOTRANSLATE    0
  //     
#define GS_PROPORTIONAL     1
  //     
#define GS_IGNOREZERO       2
// =======================================================================
#define MAX_LABEL_LENGTH      256
#define MAX_MARK_LENGTH       256
// =======================================================================
//  !
//    '...COMMON...'       
// ,         
//      .  ,    
// 'SF_COMMONGRIDX'    ,      -
// ,      SF_GRIDX.
//       ,   .
// =======================================================================
//     
#define SF_GRIDX              (1<<0)
//     
#define SF_GRIDY              (1<<1)
//           
#define SF_COMMONGRIDX        (1<<2)
//           
#define SF_COMMONGRIDY        (1<<3)
//       
#define SF_AUTOGRIDX          (1<<4)
//       
#define SF_AUTOGRIDY          (1<<5)
//      
#define SF_LABELX             (1<<6)
//      
#define SF_LABELY             (1<<7)
//           
#define SF_COMMONLABELX       (1<<8)
//           
#define SF_COMMONLABELY       (1<<9)
//      
#define SF_MARKX              (1<<10)
//      
#define SF_MARKY              (1<<11)
//            
#define SF_COMMONMARKX        (1<<12)
//            
#define SF_COMMONMARKY        (1<<13)
//   
#define SF_AXISX              (1<<14)
//   
#define SF_AXISY              (1<<15)
//  
#define SF_AUTOSCALEFONT      (1<<16)
// =======================================================================
//      
class                   CFormattedMessage
{
private:
  char                  lpBuffer[512];
public:
  char                  szAppTitle[128];
  HWND                  hWnd;
  void                  Report(const char *fmt, ...);
  //  'DisplayString'      ,
  //  ,     
  virtual void          DisplayString(char *lpszString,DWORD dwButtons)
  {
    ::MessageBox(hWnd,lpszString,szAppTitle,dwButtons);
  }
};
// =======================================================================
//      
class                   CWarnReport : public CFormattedMessage
{
  public:
  void DisplayString(char *lpszStr, DWORD dwButtons)
  {
    CFormattedMessage::DisplayString(lpszStr,MB_OK|MB_ICONEXCLAMATION);
  }
};
// =======================================================================
//       
class                   CErrorReport : public CFormattedMessage
{
  public:
  void DisplayString(char *lpszStr, DWORD dwButtons)
  {
    CFormattedMessage::DisplayString(lpszStr,MB_OK|MB_ICONHAND);
  }
};
// =======================================================================
//        
class                   CFatalErrorReport : public CFormattedMessage
{
  public:
  void DisplayString(char *lpszStr, DWORD dwButtons);
};
// =======================================================================
//  'MemOverride'    
// ; ,    ,  ..
class           MemOverride
{
public:
  LPVOID malloc(DWORD dwSize); // {return ::malloc(dwSize);}
  void   free(void *lpBlock); // {::free(lpBlock);}
};
// =======================================================================
//              p 
class           CWindowBase
#ifdef          MEM_OVERRIDE
  : public CFormattedMessage, public MemOverride
#else
  : public CFormattedMessage
#endif
{
protected:
  ATOM          ClassId;
  WNDCLASS      wc;
  char          ClassName[128];
  BOOL          bSuperclassed;
  //            pp p 
  HWND          parent;
  //             
  char          *title;
  //             
  DWORD         style;
  //            p   
  int           x, y;
  int           width, height;
  HACCEL        haccel;
  HWND          hwnd;
  HINSTANCE     hinstance;
  BOOL          bInOnClose;
  WNDPROC       DefaultWindowProc;
  friend long FAR PASCAL GlobalWindowProc(HWND hWnd, 
    UINT message, WPARAM wParam, LPARAM lParam);
public:
  virtual void  DisplayString(char *lpszString,DWORD dwButtons)
  {
    CFormattedMessage::DisplayString(lpszString,MB_OK);
  }
  BOOL          bCreated;               //   
  BOOL          bSuspend;               //    p 
  BOOL          InOnClose() {return bInOnClose;}
                CWindowBase();
  virtual       ~CWindowBase();
  HWND          GetWnd()                { return hwnd;                  }
  HWND          GetParent()             { return parent;                }
  HINSTANCE     GetInstance()           { return hinstance;             }
  //             
  virtual DWORD OverrideDefaults(int Default) { return OD_DEFAULT;      }
  BOOL          Create(HINSTANCE hInstance, int nCmdShow);
  BOOL          CreateAndShow(HINSTANCE hInstance, int nCmdShow);
  int           MessageLoop();
  //             
  void          SetTitle(LPSTR lpszTitle);
  void          SetPos(RECT &rc);
  //                 
  void          Invalidate();
  //                
  //  !!! - OnCreate      WM_CREATE,  -
  //    CreateWindow.
  virtual long  OnCreate(HWND hWnd)     { return 0L;                    }
  //
  virtual void  OnInitialUpdate()       {                               }
  virtual BOOL  OnClose()               { return TRUE;                  }
  virtual void  OnPaint(HDC dc, RECT &rcUpdate, BOOL bErase)    {       }
  virtual LPARAM OnCommand(WORD wId,WORD wNotifyCode,HWND hCtrl) 
  {      
    return 1;
  }
  //            if(res!=0 && res!=-1) -  p
  virtual LPARAM OnEvent(UINT message, WPARAM wParam,LPARAM lParam)
  {
    return 1;
  }
  //
  LRESULT       Perform(UINT Msg,WPARAM wParam,LPARAM lParam);
  virtual void  OnIdle();
};
// =======================================================================
//                
class           CMenu
#ifdef          MEM_OVERRIDE
  : public      MemOverride
#endif
{
private:
  CWindowBase   *win;
  BOOL          bLoadedFromResource;
  int           iNextPopupPtr;
protected:
  HMENU         hmenupopup[MAX_POPUP_ITEM];
  HMENU         hmenumain;
public:
                CMenu();
                ~CMenu();
  void          Load(LPSTR lpResource);
  void          Load(int iResource);
  void          Destroy();
  void          Set(CWindowBase &cWnd);
  void          Create(int iPopups);
  void          NextPopup(LPSTR lpItemName);
  void          AppendTo(int iPopup, UINT fuFlags, UINT idNewItem,
                  LPCSTR lpNewItem);
  void          EnableItem(UINT idEnableItem, UINT uEnable);
  void          CheckItem(UINT idCheckItem, UINT uCheck);
};
// =======================================================================
//                 
class           CDialog
#ifdef          MEM_OVERRIDE
  : public      MemOverride
#endif
{
protected:
  HINSTANCE     ParentInstance;
  HWND          ParentWnd;
  LPSTR         lpTemplate;
  CDialog       *PrevModalDialog;
public:
                CDialog(LPSTR lpTemplate, HWND hWnd=NULL);
                CDialog(int iTemplate, HWND hWnd=NULL);
                CDialog(LPSTR lpTemplate, CWindowBase &Parent);
                CDialog(int iTemplate, CWindowBase &Parent);
  virtual       ~CDialog() {}
  BOOL          DoModal();
  virtual LRESULT OnInitDialog(HWND hDlg, HWND hFocus);
  virtual LRESULT OnCommand(HWND hDlg, WPARAM idControl);
};
// =======================================================================
#ifdef          OLD_VER_COMPAT
//                 GDI -  .
class           CGDIObject
#ifdef          MEM_OVERRIDE
  : public      MemOverride
#endif
{
  HDC           hdc;
  HGDIOBJ       newobj, oldobj;
public:
  HGDIOBJ       &NewObject() { return newobj; }
  HDC           &GetDC() { return hdc; }
                CGDIObject::CGDIObject(HDC hdc)
  {
    this->hdc=hdc;
    oldobj=NULL;
  }
                CGDIObject::~CGDIObject()
  {
    ::SelectObject(hdc, oldobj);
    ::DeleteObject(newobj);
  }
  void          Select()
  {
    if(!oldobj) oldobj=::SelectObject(hdc, newobj);
  }
};

class CPen : public CGDIObject
{
  public:
        CPen(HDC hdc, int fnPenStyle, int nWidth, COLORREF clrref)
          : CGDIObject(hdc)
    {
      NewObject()=::CreatePen(fnPenStyle, nWidth, clrref);
      Select();
    }
    ~CPen() {}
};

class CBrush : public CGDIObject
{
  public:
        CBrush(HDC hdc, COLORREF clrref)
          : CGDIObject(hdc)
  {
    NewObject()=::CreateSolidBrush(clrref);
    Select();
  }
        ~CBrush() {}
};

#endif

#ifdef MoveTo
#undef MoveTo
#endif

#ifdef    GetTextExtentPoint
#define   GetTextExtentPoint__ GetTextExtentPoint
#undef    GetTextExtentPoint
#endif

// =======================================================================
// ,   ,   
// =======================================================================
class CPen
{
protected:
  LOGPEN        PenParams;
public:
                CPen()
  {
    //     
    PenParams.lopnStyle=PS_SOLID;
    PenParams.lopnWidth.x=1;
    PenParams.lopnWidth.y=0;
    PenParams.lopnColor=RGB(255,255,255);
  }
  virtual       ~CPen() {}
  void          SetStyle(UINT uiStyle) {PenParams.lopnStyle=uiStyle;}
  void          SetWidth(LONG lWidth) {PenParams.lopnWidth.x=lWidth;}
  void          SetColor(COLORREF crColor) {PenParams.lopnColor=crColor;}
  LOGPEN        *GetLogPen() {return &PenParams;}
};
// =======================================================================
class CBrush
{
protected:
  LOGBRUSH      BrushParams;
public:
                CBrush()
  {
    //     
    BrushParams.lbStyle=BS_SOLID;
    BrushParams.lbColor=RGB(255,255,255);
    BrushParams.lbHatch=0;
  }
  virtual       ~CBrush() {}
  void          SetColor(COLORREF crColor) {BrushParams.lbColor=crColor;}
  void          SetHatch(LONG lbHatch)
  {
    BrushParams.lbStyle=BS_HATCHED;
    BrushParams.lbHatch=lbHatch;
  }
  void          SetDibPattern(HBITMAP hDib)
  {
    BrushParams.lbStyle=BS_DIBPATTERN;
    BrushParams.lbHatch=(LONG)hDib;
  }
  void          SetStyle(LONG lbStyle) {BrushParams.lbStyle=lbStyle;}
  LOGBRUSH      *GetLogBrush() {return &BrushParams;}
};
// =======================================================================
class CFont
{
protected:
  LOGFONT       FontParams;
public:
                CFont()
  {
    FontParams.lfHeight=16;
    FontParams.lfWidth=0;
    FontParams.lfEscapement=0;
    FontParams.lfOrientation=0;
    FontParams.lfWeight=FW_DONTCARE;
    FontParams.lfItalic=FALSE;
    FontParams.lfUnderline=FALSE;
    FontParams.lfStrikeOut=FALSE;
    //  Windows NT 4.0   lfCharSet  'RUSSIAN_CHARSET'
    FontParams.lfCharSet=DEFAULT_CHARSET;
    FontParams.lfOutPrecision=OUT_DEFAULT_PRECIS;
    FontParams.lfClipPrecision=CLIP_DEFAULT_PRECIS;
    FontParams.lfQuality=DEFAULT_QUALITY;
    FontParams.lfPitchAndFamily=DEFAULT_PITCH;
    strcpy(FontParams.lfFaceName,"Arial");
  }
  virtual       ~CFont() {}
  void          SetHeight(LONG lfHeight)
  {
    FontParams.lfHeight=lfHeight;
  }
  void          SetWidth(LONG lfWidth)
  {
    FontParams.lfWidth=lfWidth;
  }
  void          SetOrientation(LONG lfOrientation)
  {
    FontParams.lfOrientation=FontParams.lfEscapement=lfOrientation;
  }
  void          SetWeight(LONG lfWeight)
  {
    FontParams.lfWeight=lfWeight;
  }
  void          SetItalic(BYTE lfItalic)
  {
    FontParams.lfItalic=lfItalic;
  }
  void          SetUnderline(BYTE lfUnderline)
  {
    FontParams.lfUnderline=lfUnderline;
  }
  void          SetStrikeOut(BYTE lfStrikeOut)
  {
    FontParams.lfStrikeOut=lfStrikeOut;
  }
  void          SetCharSet(BYTE lfCharSet)
  {
    FontParams.lfCharSet=lfCharSet;
  }
  void          SetOutPrecision(BYTE lfOutPrecision)
  {
    FontParams.lfOutPrecision=lfOutPrecision;
  }
  void          SetClipPrecision(BYTE lfClipPrecision)
  {
    FontParams.lfClipPrecision=lfClipPrecision;
  }
  void          SetQuality(BYTE lfQuality)
  {
    FontParams.lfQuality=lfQuality;
  }
  void          SetPitchAndFamily(BYTE lfPitchAndFamily)
  {
    FontParams.lfPitchAndFamily=lfPitchAndFamily;
  }
  void          SetFaceName(char *szFaceName)
  {
    strncpy(FontParams.lfFaceName,szFaceName,LF_FACESIZE);
  }
  LOGFONT       *GetLogFont()
  {
    return &FontParams;
  }
};
// =======================================================================
//    ,   .
// ,     GDI, .
// =======================================================================
class           CDCObject : public CFormattedMessage
#ifdef          MEM_OVERRIDE
  , public MemOverride
#endif
{
protected:
  HWND                  HandleWND;
  HDC                   HandleDC;
  HGDIOBJ               hBrushOld,hBrush;
  HGDIOBJ               hFontOld,hFont;
  HGDIOBJ               hPenOld,hPen;
  RECT                  rcPaintArea;
  int                   nCurrentOrientation;
  void                  DeleteBrush();
  void                  DeleteFont();
  void                  DeletePen();
  void                  ResetAll();
  void                  ReleaseAll();
  BOOL                  bLastError;
public:
  BOOL                  LastError() {return bLastError;}
                        CDCObject(HDC hDC);
  virtual               ~CDCObject();
  HWND                  &GetWnd() {return HandleWND;}
  HDC                   &GetDC() {return HandleDC;}
  HGDIOBJ               &GetBrush() {return hBrush;}
  HGDIOBJ               &GetFont() {return hFont;}
  HGDIOBJ               &GetPen() {return hPen;}
// =======================================================================
//   GDI
// =======================================================================
  void  CreatePen(int fnPenStyle,int nWidth,COLORREF crColor);
  void  CreatePenIndirect(CONST LOGPEN *lplgpn);
  void  CreateBrushIndirect(CONST LOGBRUSH *lplb);
  void  CreateDIBPatternBrush(HGLOBAL hglbDIBPacked,UINT fuColorSpec);
  void  CreateDIBPatternBrushPt(CONST VOID *lpPackedDIB,UINT iUsage);
  void  CreatePatternBrush(HBITMAP hbmp);
  void  CreateSolidBrush(COLORREF crColor);
  void  CreateFont(int nHeight,int nWidth,int nEscapement,
    int nOrientation,int fnWeight,DWORD fdwItalic,DWORD fdwUnderline,
    DWORD fdwStrikeOut,DWORD fdwCharSet,DWORD fdwOutputPrecision,
    DWORD fdwClipPrecision,DWORD fdwQuality,DWORD fdwPitchAndFamily,
    LPCTSTR lpszFace);
  void  CreateFontIndirect(CONST LOGFONT *lplf);
//     ,   :
//   nWidth -  ;
//   nEscapement  nOrientation -  ;
//   fnWeight -  FW_NORMAL;
//   fdwItalic  fdwUnderline -  FALSE;
//   fdwCharSet -  DEFAULT_CHARSET;
//   fdwStrikeOut -  FALSE;
//   fdwOutputPrecision -  OUT_DEFAULT_PRECIS;
//   fdwClipPrecision -  CLIP_DEFAULT_PRECIS;
//   fdwQuality -  NONANTIALIASED_QUALITY;
//   fdwPitchAndFamily -  DEFAULT_PITCH||FF_DONTCARE.
  void  CreateFont(int nSize,LPCTSTR lpszFace);
  void  CreateFont(int nHeight,int nWidth,int nOrientation,
    LPCTSTR lpszFace);
  void  CreateFont(int nHeight,int nWidth,int nOrientation,
    int fnWeight,DWORD fdwItalic,DWORD fdwUnderline,LPCTSTR lpszFace);
//      GDI   
  void CreateFont(CFont *lpFont);
  void CreatePen(CPen *lpPen);
  void CreateBrush(CBrush *lpBrush);
// =======================================================================
//   GDI
// =======================================================================
  void  SetPixel(int X, int Y, COLORREF Color)
  {
    ::SetPixel(HandleDC,X,Y,Color);
  }
  void  AngleArc(int X,int Y,DWORD dwRadius,FLOAT eStartAngle,
    FLOAT eSweepAngle);
  void  LineTo(int x,int y);
  void  Polyline(CONST POINT *lppt,int cPoints);
  void  Arc(int nLeftRect,int nTopRect,int nRightRect,int nBottomRect,
    int nXStartArc,int nYStartArc,int nXEndArc,int nYEndArc);
  void  MoveToEx(int X,int Y,LPPOINT lpPoint);
  void  PolylineTo(CONST POINT *lppt,DWORD cCount);
  void  ArcTo(int nLeftRect,int nTopRect,int nRightRect,int nBottomRect,
    int nXRadial1,int nYRadial1,int nXRadial2,int nYRadial2);
  void  Pie(int nLeftRect,int nTopRect,int nRightRect,int nBottomRect,
    int nXRadial1,int nYRadial1,int nXRadial2,int nYRadial2);
  void  PolyPolygon(CONST POINT *lpPoints,CONST INT *lpPolyCounts,
    int nCount);
  void  Chord(int nLeftRect,int nTopRect,int nRightRect,int nBottomRect,
    int nXRadial1,int nYRadial1,int nXRadial2,int nYRadial2);
  void  PolyBezier(CONST POINT *lppt,DWORD cPoints);
  void  PolyBezierTo(CONST POINT *lppt,DWORD cCount);
  void  Rectangle(int left,int top,int right,int bottom);
  void  Ellipse(int nLeftRect,int nTopRect,int nRightRect,
    int nBottomRect);
  void  PolyDraw(CONST POINT *lppt,CONST BYTE *lpbTypes,int cCount);
  void  RoundRect(int nLeftRect,int nTopRect,int nRightRect,
    int nBottomRect,int nWidth,int nHeight);
  void  ExtTextOut(int X,int Y,UINT fuOptions,CONST RECT *lprc,
    LPCTSTR lpString,UINT cbCount,CONST INT *lpDx);
  void  Polygon(CONST POINT *lpPoints,int nCount);
  void  TextOut(int x,int y,char *lpStr,int cbString);
  void  PolyPolyline(CONST POINT *lppt,CONST DWORD *lpdwPolyPoints,
    DWORD cCount);
  void  PatBlt(int nXLeft,int nYLeft,int nWidth,int nHeight,DWORD dwRop);
  void  Line(int x1,int y1,int x2,int y2);
//    ( 'Polyline')
  void  HollowRectangle(RECT *lpRc);
//    ( cbString == strlen(lpStr))
  void  TextOut(int x,int y,char *lpStr);
//    Windows 3.X
  void  MoveTo(int X,int Y);
//   'nXLeft'  'nHeight'   'lprcArea'
  void  PatBlt(RECT *lprcArea,DWORD dwRop);
// =======================================================================
//   
// =======================================================================
  void  SetTextAlign(UINT fMode);
  void  SetTextCharacterExtra(int nCharExtra);
  void  SetTextColor(COLORREF crColor);
  void  SetBkColor(COLORREF crColor);
  void  SetMapMode(int fnMapMode);
  void  SetBkMode(int iBkMode);
  void  SetTextJustification(int nBreakExtra,int nBreakCount);
// =======================================================================
// 
// =======================================================================
  virtual void  GetTextExtentPoint(LPCTSTR lpString,int cbString,
    LPSIZE lpSize);
  void  GetTextExtentPoint(LPCTSTR lpString,LPSIZE lpSize);
// =======================================================================
//        ,
//     . :
// lpString -   ;
// lpOrigin -   ,    
//    'TextOut'   ;
// aVertices - ,    ;
// bLooped -    ,     
//   .   'Polyline'.
// =======================================================================
  void  GetTextRect(LPCTSTR lpString,POINT *lpOrigin,
    POINT *aVertices,
    BOOL bLooped=FALSE);
  //       
  virtual BOOL GetClientArea(RECT *lpRcClient) {return FALSE;}
};
// =======================================================================
//  CDCObject,    
// =======================================================================
class CClientDC : public CDCObject
{
public:
  CClientDC(HDC hDC) : CDCObject(hDC) {}
  CClientDC(CWindowBase *lpOutputFrame);
  BOOL GetClientArea(RECT *lpRcClient);
};
// =======================================================================
// 28.07.98
//  CDCObject,     
// =======================================================================
class CMetafileDC : public CDCObject
{
private:
  char              *szFileName;
  RECT              BoundsRect;
public:
  //  :
  // szFileName -  ,     
  // lpRcInches1000 -    (   )
  //     NULL,      A4
                    CMetafileDC(char *szFileName, RECT *lpRcInches1000);
  virtual           ~CMetafileDC();
  virtual void      GetTextExtentPoint(LPCTSTR lpString,int cbString,
    LPSIZE lpSize);
  BOOL              GetClientArea(RECT *lpRcClient);
};

// =======================================================================
//  p  p  p 
// =======================================================================
class           COFNBase
#ifdef          MEM_OVERRIDE
  : public      MemOverride
#endif
{
protected:
  char          DirName[_MAX_DIR];
  char          File[3+_MAX_DIR+_MAX_FNAME+_MAX_EXT];
  char          FileTitle[_MAX_FNAME];
  OPENFILENAME  ofn;
  BOOL          bLastError;
public:
  BOOL          LastError() {return bLastError;}
};

class           CFileOpenDialog : public COFNBase
{
public:
                CFileOpenDialog(HWND hwnd, char *title = NULL,
    char *filter=NULL, char *dirname=NULL, char *filename=NULL);
  char          *GetName() { return File; }
  void          DoModal();
};

class           CFileSaveDialog : public COFNBase
{
public:
                CFileSaveDialog(HWND hwnd, char *title = NULL,
    char *filter=NULL, char *dirname=NULL, char *filename=NULL);
  char          *GetName() { return File; }
  void          DoModal();
};
// =======================================================================
//     - 
// =======================================================================
class                   CInputBinaryFile
#ifdef                  MEM_OVERRIDE
  : public MemOverride
#endif
{
protected:
  int                   iHandle;
  DWORD                 dwPos;
  DWORD                 dwSize;
  DWORD                 dwFlags;
  BOOL                  bLastError;
  void                  *lpFileBuffer;
public:
  BOOL                  LastError() {return bLastError;}
  char                  PathName[_MAX_PATH];
  char                  Drive[_MAX_DRIVE], Dir[_MAX_DIR],
                        Name[_MAX_FNAME],Ext[_MAX_EXT];
                        CInputBinaryFile(char *lpszPathName);
  virtual               ~CInputBinaryFile();
  void                  Preload(BOOL bUseSharedPool=FALSE);
  void                  *GetBuffer(void) {return lpFileBuffer;}
  void                  seek(long lOffeset, DWORD dwSeekType);
  DWORD                 tell(void);
  BOOL                  eof(void);
  DWORD                 filesize(void);
  DWORD                 read(void *lpBuffer, DWORD dwLength);
};
// =======================================================================
class                   CInputTextFile : public CInputBinaryFile
{
  public:
                        CInputTextFile(char *lpszPathName):
                        CInputBinaryFile(lpszPathName) {}
  void                  SetWrapMode(int iWMode);
  UCHAR                 getch();
  DWORD                 gets(char *lpszBuffer, DWORD dwLimit);
  DWORD                 scan(char *lpszBuffer, DWORD dwlimit);
};
// =======================================================================
//     - 4 
#define         OBF_CASHESIZE           4096
//      - 32 
#define         OBF_MAXCASHESIZE        16*1024*1024
class           COutputBinaryFile : public CFormattedMessage
#ifdef                  MEM_OVERRIDE
  , public MemOverride
#endif
{
  BOOL          bLastError;
  BOOL          bAlreadyExists;
  BOOL          bOverWrite;
  char          *lpszFileName;      //    
  int           iHandle;            //   
  BYTE          *lpCache;           //    
  DWORD         dwCacheSize;        //   
  DWORD         dwCachePos;         //     
  void          ResetAll();
  void          ReleaseAll();
public:
  BOOL          LastError() {return bLastError;}
  BOOL          IsExists() {return bAlreadyExists;}
  //    -       
                COutputBinaryFile(char *lpszFileName,
    DWORD dwSizeCache=OBF_CASHESIZE);
  virtual       ~COutputBinaryFile();
  //       
  void          Commit();
  //      /
  void          write(void *lpBuffer, DWORD dwBufferSize);
  //       
  virtual void          DisplayString(char *lpszString,DWORD dwButtons);
};
// =======================================================================
class           COutputTextFile : public COutputBinaryFile
{
private:
  char          lpszBuffer[1024];
public:
  COutputTextFile(char *lpszFileName,DWORD dwSizeCache=OBF_CASHESIZE):
    COutputBinaryFile(lpszFileName,dwSizeCache) {}
  ~COutputTextFile() {}
  void          putch(char ch);
  void          puts(char *str);
  void          printf(const char *fmt, ...);
};
// =======================================================================
//  .      1998 .,  -
//  -   'af15graph'.   1998 .   
// .
// =======================================================================
typedef struct tagTGraphVertex2d
{
  double x, y;
} TGraphVertex2d;
//    
class CGraphicsSamples : public MemOverride
{
private:
  //  
  int           iVertexCount;
  //         
  int           iMaxVertex;
  //     VertexXX
  int           iSamplesType;
  //      
  double        MinX,MaxX,MinY,MaxY;
  double        CustomMinX,CustomMaxX,CustomMinY,CustomMaxY;
  BOOL          bMinMaxValid;
  BOOL          bUseCustomMinMaxX;
  BOOL          bUseCustomMinMaxY;
  // == TRUE       
  BOOL          bInsidePath;
  //  ,      
  DWORD         fuDefinedArrays;
  //   
  TGraphVertex2d *lpVertices;
  //  
  TGraphVertex2d vZeroPoint;
  //  
  TGraphVertex2d vZoom;
  //  
  double        dAngle;
  //  
  DWORD         *lpRGBTriples;
  //  
  BOOL          bLastError;
  // ,    
  CDCObject     *lpCDC;
  //  
  RECT          rcOut;
  //   
  CPen          *lpInitialPen;
  //   
  CBrush        *lpInitialBrush;
  //     
  void          AllocateArrays();
  //   ,     
  void          ReleaseArrays();
  //        
  void          ResetMinMax();
public:
                CGraphicsSamples(CDCObject *lpCDC);
  virtual       ~CGraphicsSamples();
  // =====================================================================
  //  1.  .
  //  ,   
  void          BeginPath(int iMaxVertex);
  //    
  void          Vertex2d(double x, double y);
  void          Vertex2i(int x, int y);
  void          Color3d(double r, double g, double b);
  void          Color3i(int r, int g, int b);
  //  ,    
  void          EndPath();
  //    :
  //      .  'iStride' 
  //      'y'    -
  //  'x'  .   
  // ,       0.
  void          VertexPointer2d(int iStride,int iCount,void *aVertices);
  void          VertexPointer2i(int iStride,int iCount,void *aVertices);
  //       .
  void          ColorPointer1i(int iStride,int iCount,void *aRGBTriples);
  //     
  void          DrawArrays(int iDrawMode);
  // =====================================================================
  //  2.     .
  void          GetMinMaxX(double *MinX, double *MaxX);
  void          GetMinMaxY(double *MinY, double *MaxY);
  void          UseCustomMinMaxX(double MinX, double MaxX, BOOL bUse);
  void          UseCustomMinMaxY(double MinY, double MaxY, BOOL bUse);
  void          Scale(double dFactorX, double dFactorY);
  void          Translate(double dTranslateX, double dTranslateY);
  void          Rotate(double Angle, double CX, double CY);
  //    
  void          SetOutputRect(RECT *lprcOut);
  void          GetOutputRect(RECT *lprcOut);
  //    
  void          ScaleFromArrays(double dReqSizeX, double dReqSizeY,
    DWORD fuScaleFlags);
  void          TranslateFromArrays(double dReqStartX, double dReqStartY,
    DWORD fuFlags);
  // =====================================================================
  CPen          *GetPen() {return lpInitialPen;}
  CBrush        *GetBrush() {return lpInitialBrush;}
  TGraphVertex2d *GetZeroPoint() {return &vZeroPoint;}
  TGraphVertex2d *GetZoom() {return &vZoom;}
  double         *GetRotation() {return &dAngle;}
  // =====================================================================
  BOOL          LastError() {return bLastError;}
};
//    
class CSamplesFormat
{
private:
  CDCObject     *lpDC;
  CGraphicsSamples *lpSamples;
  char          szBuffer[MAX_MARK_LENGTH];
  void          AutoLabelPlaces();
  void          DrawLabels();
  void          DrawGrid();
  DWORD         fuFlags;
  BOOL          bLastError;
  //  
  char          szLabelX[MAX_LABEL_LENGTH];
  char          szLabelY[MAX_LABEL_LENGTH];
  //     
  double        GridSizeX;
  double        GridSizeY;
  //     
  TGraphVertex2d LabelXPlace;
  TGraphVertex2d LabelYPlace;
  //  
  RECT          rcOut;
public:
  //    -     90 
  CFont         *fntLabelX;
  CFont         *fntLabelY;
  //   
  CPen          *pnGrid;
  //      (,    )
  CPen          *pnAxis;
  //    
  CPen          *pnFrame;
  //      
  int           iGridNumX;
  //      
  int           iGridNumY;
  //         
  int           iDigitsX;
  //         
  int           iDigitsY;
  //  :
  //  -   
  //  - ,     
  //  -  
                CSamplesFormat(DWORD fuInitialFlags,CDCObject *lpDC,
    CGraphicsSamples *lpSamples);
                ~CSamplesFormat();
  //     (  )
  void          SetGridSizes(double GridSizeX,double GridSizeY);
  //     
  void          UseCustomMinMaxX(double MinX, double MaxX, BOOL bUse);
  void          UseCustomMinMaxY(double MinY, double MaxY, BOOL bUse);
  //    
  void          SetLabelNames(char *szLabelX, char *szLabelY);
  //    
  void          SetOutputRect(RECT *rcOut);
  //      
  void          Draw();
};

// =======================================================================

#endif
