#include <windows.h>
#include <stdio.h>
#pragma hdrstop
#include "fft.c"

#define domain_size (16 * 1024)

vec_t   domain[domain_size << 1];
vec_t   domain_back[domain_size << 1];

void freq_fill(vec_t *dest,int samples,int rate,vec_t peak,vec_t freq)
{
   // rate -   (/)
   // peak - 
   // freq - 
   int i;
   vec_t fi,dfi;
   fi=0;
   dfi=2 * M_PI * freq / (vec_t)rate;
   for(i=0;i<samples;i++)
   {
     dest[i]=peak*sin(fi);
     fi+=dfi;
   }
}

void main()
{
  int count=0;
  int time_start, time;
  freq_fill(domain,domain_size,1024,1.0,1.0);
  memset(domain+domain_size,0,domain_size * sizeof(vec_t));
  time_start=GetTickCount();
  memcpy(domain_back,domain,domain_size<<1);
  while((GetTickCount()-time_start)<10000) {
    memcpy(domain,domain_back,domain_size<<1);
    FFTCalc(domain,domain+domain_size,domain_size);
    count++;
  }
  time=GetTickCount()-time_start;
  printf("%g seconds,%d FFT transforms,%d samples in each transform\n",
    (float)time/1000.0,count,domain_size);
}

  
  
  