/*<html><body bgcolor=#000080><font color=#C0C0B0><strong><pre>*/
#include	"../../include/v_lib.h"
#include	"../../source/v_mt.h"
#include	"v_fsutil.h"

#ifndef	RIGHT_SLASHED

int	V_CALL
uchdir(char *unix_dir_name)
{
	char os_dir[_MAX_PATH];
	strCopy(os_dir,dir,_MAX_PATH);
	fsUnix2Dos(os_dir);
	return _chdir(os_dir);
}

int	V_CALL
umkdir(char *unix_dir_name)
{
	char os_dir[_MAX_PATH];
	strCopy(os_dir,dir,_MAX_PATH);
	fsUnix2Dos(os_dir);
	return _mkdir(os_dir);
}

#endif	/* RIGHT_SLASHED */

#if 0

/*
 *	Splits full path, creates dir and name+extension
 */
void	V_LOCAL
split_dir_and_name_ext_from_path(char *dir,char *name_ext,char *full_path)
{
	char *end;
	char path[_MAX_PATH];
	int pl;
	strCopy(path,full_path,_MAX_PATH);
	pl=strlen(path);
	if(pl==0)
	{
		if(dir)
			*dir=0;
		if(name_ext)
			*name_ext=0;
		return;
	}
	for(end=path+pl-1;end>path && *end!='/';end--);
	/*	advance pointer to skip last slash.
	 */
	if(*end=='/')
		end++;
	if(name_ext)
		strCopy(name_ext,end,_MAX_FNAME+_MAX_EXT+1);
	/* dir can be NULL */
	if(dir)
	{
		/* split dir */
		end[0]=0;
		strCopy(dir,path,_MAX_DIR);
	}
}

/*
 *	Splits name and extension.
 */
void	V_LOCAL
split_name_and_ext_from_name_ext(char *name,char *_ext,char *name_and_ext)
{
	char *end;
	int ext_len;
	char name_ext[_MAX_FNAME+_MAX_EXT+1];
	char ext[_MAX_EXT];
	strCopy(name_ext,name_and_ext,_MAX_FNAME+_MAX_EXT+1);
	for(end=name_ext+strlen(name_ext)-1;end>name_ext && *end!='.';end--);
	if(end==name_ext)
		ext[0]=0;
	else
		strCopy(ext,end+1,_MAX_EXT);
	if(_ext)
		strcpy(_ext,ext); /* strCopy is not needed */
	if(name)
	{
		ext_len=strlen(ext);
		if(ext_len)
			name_ext[strlen(name_ext)-ext_len-1]=0;
		strCopy(name,name_ext,_MAX_FNAME);
	}
}

/*
 *	Splits path onto pieces.
 */
void	V_GLOBAL
fsSplitPath(char *full_path,char *drive,char *dir,char *name, char *ext)
{
	char name_ext[_MAX_FNAME+_MAX_EXT+1];
	if(!full_path || full_path[0]==0)
    {
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,
			"fsSplitPath('%s'): incorrect parameter.\n",dbs(full_path));
#endif	/* CHECKED_BUILD */
        if(drive)
        	*drive=0;
        if(dir)
        	*dir=0;
        if(name)
        	*name=0;
        if(ext)
        	*ext=0;
		return;
    }
	/* strip drive */
#ifdef	__UNIX__
	/* no drive */
	if(drive)
		drive[0]=0;
#else	/* __UNIX__ */
	/* there are two slashes before drive letter */
	if(strlen(full_path)>=3 && full_path[0]=='/' && full_path[1]=='/')
	{
		if(drive)
		{
			drive[0]=full_path[2];
			drive[1]=0;
		}
#ifdef	CHECKED_BUILD
		if(full_path[3]!='/')
			conlPrintf(LOG_WARNING,
				"fsSplitPath('%s'): directory must start with '/' if "
				"drive specified.\n",full_path);
#endif	/* CHECKED_BUILD */
		full_path+=3;
	}
	else
		if(drive)
			drive[0]=0;
#endif	/* __UNIX__ */
	split_dir_and_name_ext_from_path(dir,name_ext,full_path);
	split_name_and_ext_from_name_ext(name,ext,name_ext);
}

/*
 *	Makes full path from parts (some/all parts can be NULL).
 */
void	V_GLOBAL
fsMakePath(char *dest_path,char *drive,char *dir,char *name, char *ext)
{
	int avail,len;
	char *end;
	if(!dest_path)
    {
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,
			"fsMakePath('%s'): incorrect dest path.\n",dbs(NULL));
#endif	/* CHECKED_BUILD */
		return;
	}
	avail=_MAX_PATH;
	end=dest_path;
	*end=0;
#ifndef	__UNIX__
	if(drive && drive[0])
	{
		end[0]=end[1]='/';
		end[2]=drive[0];
		if(!dir || *dir!='/')
		{
#ifdef	CHECKED_BUILD
			conlPrintf(LOG_WARNING,
				"fsMakePath('%s','%s','%s','%s'): directory must be "
				"absolute if drive specified.\n",dbs(drive),dbs(dir),
				dbs(name),dbs(ext));
#endif	/* CHECKED_BUILD */
			end[3]='/';
			end[4]=0;
			avail--;
			end++;
		}
		else
			end[3]=0;
		avail-=3;
		end+=3;
	}
#endif	/* __UNIX__ */
	if(dir)
	{
		len=strlen(dir);
		if(len)
		{
			strCopy(end,dir,avail);
			avail-=len;
			if(avail<=0)
				return;
			end+=len;
			if(end[-1]!='/')
			{
				*end='/';
				end++;
				*end=0;
				avail--;
			}
		}
	}
	if(name)
	{
		len=strlen(name);
		if(len)
		{
			strCopy(end,name,avail);
			avail-=len;
			if(avail<=0)
				return;
			end+=len;
			if(end[-1]!='.')
			{
				*end='.';
				end++;
				*end=0;
				avail--;
			}
		}
	}
	else
	{
		if(ext && ext[0])
		{
#ifdef	CHECKED_BUILD
			conlPrintf(LOG_WARNING,
				"fsMakePath('%s','%s','%s','%s'): name is empty - "
				"extension ignored.\n",dbs(drive),dbs(dir),
				dbs(name),dbs(ext));
#endif	/* CHECKED_BUILD */
		}
		*end=0;
		return;
	}
	if(ext)
	{
		len=strlen(ext);
		if(len)
			strCopy(end,ext,avail);
	}
}

#ifndef	RIGHT_SLASHED

/*
 *	Converts dos path to unix form
 */
char_p	V_GLOBAL
fsNative2Unix(char *path)
{
	int i;
	char dst_buf[_MAX_PATH];
	char *dst=dst_buf, *orig;
	int max_dest=_MAX_PATH;
	if(!path)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,
			"fsDos2Unix('%s'): incorrect path.\n",dbs(NULL));
#endif	/* CHECKED_BUILD */
		return dbs(NULL);
	}
	orig=path;
	max_dest--;
	if(path[1]==':' && max_dest>2)
	{
		/* drive present */
		dst[0]=dst[1]='/';
		dst[2]=path[0];
		path+=2;
		dst+=3;
		max_dest-=3;
	}
	for(i=0;i<max_dest;i++)
	{
		if(*path=='\\')
			*dst = '/';
		else
			*dst=*path;
		if(!*path)
			break;
		dst++;
		path++;
	}
	*dst=0;
	strCopy(orig,dst_buf,_MAX_PATH);
	return orig;
}

/*
 *	Converts unix path to dos form
 */
char_p	V_GLOBAL
fsUnix2Native(char *path)
{
	int count;
	char dst_buf[_MAX_PATH];
	char *dst=dst_buf, *orig;
	int max_dest=_MAX_PATH-1;
	if(!path)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,
			"fsUnix2Dos('%s'): incorrect path.\n",dbs(NULL));
#endif	/* CHECKED_BUILD */
		return dbs(NULL);
	}
	orig=path;
	if(path[0]=='/' && path[1]=='/')
	{
		dst[0]=path[2];
		dst[1]=':';
		count=3;
		dst+=2;
		max_dest-=3;
	}
	else
		count=0;
	for(;count<max_dest;count++)
	{
		if(path[count]=='/')
			*dst='\\';
		else
			*dst=path[count];
		dst++;
		if(!path[count])
			break;
	}
	*dst=0;
	strCopy(orig,dst_buf,_MAX_PATH);
	return orig;
}

#endif	/* RIGHT_SLASHED */

/*
 *	Replaces extension in filename
 */
void	V_GLOBAL
fsReplaceExt(char *dst,char *name,char *ext)
{
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_FNAME];
	if(!dst || !name || !ext)
    {
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,
			"fsReplaceExt('%s','%s',%s'): incorrect parameter(s).\n",
			dbs(dst),dbs(name),dbs(ext));
#endif	/* CHECKED_BUILD */
		return;
	}
	fsSplitPath(name,drive,dir,fname,NULL);
	fsMakePath(dst,drive,dir,fname,ext);
}

#endif

/*</pre></strong></body></html>*/
/*EOF*/
