#include <windows.h>
#include <stdio.h>

static	char	text[256] = "press a key...";
static	char	bin[36];

char	*IntToBin(DWORD val)
{
    char *ptr;
    DWORD mask=1<<31;
    for(ptr=bin;;mask>>=1)
    {
    	if(val & mask)
        	*ptr='1';
		else
        	*ptr='0';
        ptr++;
		if(mask==1)
        	break;
	}
    *ptr=0;
    return bin;
}
    
LRESULT CALLBACK
WindowProc(HWND win,UINT msg,WPARAM wparam,LPARAM lparam)
{
	PAINTSTRUCT ps;
	unsigned char code;
    switch(msg)
    {
    	case WM_DESTROY:
        	PostQuitMessage(0);
            return 0;
		case WM_KEYDOWN:
		case WM_SYSKEYDOWN:
			code=(unsigned char)((lparam >> 16) & 0xFF);
        	sprintf(text,"VK [%u], LP [%s] SC [%u]   ",
            	wparam,IntToBin(lparam),code);
            InvalidateRect(win,NULL,FALSE);
            if(wparam==VK_F1)
            {
            	MessageBox(win,
                	"This simple program displays Win32 virtual "
                    "key codes and extended codes, posted to "
                    "application with WM_KEYDOWN/WM_SYSKEYDOWN messages.\n"
                    "Usage: press key and see code.\n"
                    "Click at white cross to exit (Alt+F4 disabled).\n"
                    "Main window:\n"
                    "'VK'\t-\tvirtual key code from wParam;\n"
                    "'LP'\t-\tbits in lParam;\n"
                    "'SC'\t-\tscan code (== (lParam >> 16) & 0xFF).\n"
                    "Author: Vladimir A. Smirnov, (841-2)57-07-99.",
                    "Virtual codes",
                    MB_ICONINFORMATION);
            }
            return 0;
            break;
		case WM_PAINT:
        	BeginPaint(win,&ps);
            /* Nice close button :) */
    		MoveToEx(ps.hdc,339,10,NULL);
    		LineTo(ps.hdc,350,0);
		    MoveToEx(ps.hdc,339,0,NULL);
    		LineTo(ps.hdc,350,10);
    		LineTo(ps.hdc,339,10);
    		LineTo(ps.hdc,339,0);
    		LineTo(ps.hdc,349,0);
    		LineTo(ps.hdc,349,10);
            TextOut(ps.hdc,10,5,text,strlen(text));
            EndPaint(win,&ps);
            return 0;
		case WM_LBUTTONDOWN:
        	if(LOWORD(lparam)>340 && HIWORD(lparam)<10)
            	DestroyWindow(win);
			return 0;
	}
    return DefWindowProc(win,msg,wparam,lparam);
}

int
Init(void)
{
	WNDCLASS wc;
    HWND win;
    HDC dc;
    ZeroMemory(&wc,sizeof(WNDCLASS));
    wc.style=CS_OWNDC;
    wc.hbrBackground=GetStockObject(BLACK_BRUSH);
    wc.hInstance=GetModuleHandle(NULL);
    wc.lpfnWndProc=WindowProc;
    wc.hIcon=LoadIcon(NULL,IDI_WINLOGO);
    wc.hCursor=LoadCursor(NULL,IDC_ARROW);
    wc.lpszClassName="wmkd_class";
    if(!RegisterClass(&wc))
    	return 0;
	win=CreateWindow(
    	"wmkd_class",
        "WM_KEYDOWN test",
        WS_POPUP|WS_VISIBLE,
        GetSystemMetrics(SM_CXSCREEN)-350,
        0,
        350,
        28,
        NULL,
        NULL,
        wc.hInstance,
        NULL
    	);
	if(!win)
    	return 0;
	dc=GetDC(win);
	SelectObject(dc,GetStockObject(ANSI_VAR_FONT));
    SelectObject(dc,GetStockObject(WHITE_PEN));
    SetBkMode(dc,OPAQUE);
    SetTextColor(dc,RGB(255,255,200));
    SetBkColor(dc,0);
    SetWindowPos(win,HWND_TOPMOST,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE);
    return 1;
}

int	WINAPI
WinMain(HINSTANCE hInst,HINSTANCE hStub,LPSTR szCmdLine,int nShow)
{
	MSG msg;
    if(!Init())
    	return -1;
	while(GetMessage(&msg,NULL,0,0))
    {
    	TranslateMessage(&msg);
        DispatchMessage(&msg);
	}
    return 0;
}
    
