#ifdef		__linux
#include 	<sys/io.h>
#include	<unistd.h>
#include	<malloc.h>
#include	<stdlib.h>
#include 	<sys/fcntl.h>
#include 	<sys/stat.h>
#include 	<sys/types.h>
#include 	<sys/mman.h>
#elif		defined(__CYGWIN32__)
#include 	<io.h>
#include 	<sys/fcntl.h>
#include 	<sys/stat.h>
#include 	<sys/types.h>
#include 	<sys/mman.h>
#elif		defined(__WIN32__)
#include	<windows.h>
#endif		/* UNIX */

typedef struct file_map_s
{
	int		handle;
	size_t	len;
	void	*base;
}	file_map_t, *file_map_p;

file_map_p
fmOpenRead(char *file_name)
{
	int fd;
	struct stat st;
	void *base;
	file_map_p res;
	fd=open(file_name,0600);
	if(fd==-1)
	{
		printf("mmapOpen(%s): open() failed.\n",file_name);
		return NULL;
	}
	fstat(fd,&st);
	base=mmap(NULL,st.st_size,PROT_READ,MAP_PRIVATE,fd,0);
	if(!base || (int)base==-1)
	{
		printf("mmapOpen(%s): mmap() failed.\n",file_name);
		close(fd);
		return NULL;
	}
	res=(file_map_t*)malloc(sizeof(file_map_t));
	res->handle=fd;
	res->len=st.st_size;
	res->base=base;
	return res;
}

void
fmClose(file_map_t *file_map)
{
	munmap(file_map->base,file_map->len);
	close(file_map->handle);
	free(file_map);
}

/*
**	DEBUG
*/

int main()
{
	file_map_p fm;
	fm=fmOpenRead("mapped");
	if(fm)
	{
		printf("mmap() succeded, base is %X\n",fm->base);
		printf("Byte 3 in map set to %d\n",((char*)fm->base)[2]);
		fmClose(fm);
		return 0;
	}
	return -1;
}
