#include "../../include/v_lib.hpp"
#include <stdio.h>

static int second = 0;
static int count = 0;
static int fps;

void __stdcall idle(void)
{
  char buf[128];
  if(timeMilliseconds() >= 1000)
  {
    fps = count * 1000 / timeMilliseconds();
    count = 0;
    timeStart();
  }
  count++;
  sprintf(buf,"fps %d",fps);
  
  setbkindex(0);
  clearviewport();

  setbkindex(256-48);
  triangle(0,0,getmaxx()-1,0,getmaxx()-1,getmaxy()-1);
  setbkindex(256-50);
  triangle(getmaxx()-1,getmaxy()-1,0,getmaxy()-1,0,0);
  int i;
  for(i=0;i<256;i++)
  {
    setbkindex(i);
    int x,y;
    x=10 + (i % 16) * 16;
    y=10 + (i / 16) * 10;
    bar(x,y,x+12,y+8);
  }
  int cx,cy;

  settextindex(255);
  getextent(buf,&cx,&cy);
  moveto(getmaxx()-cx,getmaxy()-cy);
  outtext(buf);
  graphFlush(graphGetCurrentContext());
  timeDelay(10);
}

void main()
{
  conStartConsoleLog();
  conUpperLevel(LOG_TRACE);
  graph_settings_t gs={320,240,0,0,};

  gc_t c=graphCreateContext(&gs);
  if(!c) {
    con_printf("Can't create context\n");
    return;
  }
  graphSetHandler(c,evtype_idle,idle);
  graphMakeCurrent(c);

  fsInit("rc");
  loadpalette("colorpal.lmp");
  fsShutdown();
  timeStart();
  graphSysMessageloop();
}
