int comp(const void *a,const void *b)
{
	int x=*((int*)a),y=*((int*)b);
	if(x<y) return -1;
	else if(x>y) return 1;
	else return 0;
}


void sort_r( int *a, int l, int r )
{
	int i,j,x,y;
	i = l;
	j = r;
	x = a[ (l+r) >> 1 ];
	do
	{
		while( a[ i ] < x ) i++;
		while( x < a[ j ] ) j--;
		if( /* i <= j */ comp(&i,&j) <= 0 )
		{
			y = a[i]; 
			a[i]=a[j]; 
			a[j]=y;
			i++; 
			j--;
		}
	} while( i <= j );
	if( l<j ) sort_r(a,l,j);
	if( i<r ) sort_r(a,i,r);
}

void	sort(int *a,int len)
{
	sort_r(a,0,len-1);
}

/*
TODO: make tlists thread-safe.

tlistLock()		- to prevent calls of tlistVertex() which can change triangle storage base;
tlistUnlock()	- to allow such calls.

and these:

void	V_LOCAL
vpsSort_r(void *pointers,u32_t l,u32_t r,int (V_CALL *compar)(void*,void*,void*),void *param)
{
	u32_t i,j;
	void *x,*y;
	i = l;
	j = r;
	x = pointers[ (l+r) >> 1 ];
	do
	{
		while(compar(pointers[i],x,param)<0)
			i++;
		while(compar(x,pointers[j],param)<0)
			j--;
		if(compar(pointers[i],pointers[j],param)<=0)
		{
			y=pointers[i]; 
			pointers[i]=pointers[j]; 
			pointers[j]=y;
			i++; 
			j--;
		}
	} while(i<=j);
	if(l<j)
		vpsSort_r(pointers,l,j,compar,param);
	if(i<r)
		vpsSort_r(pointers,i,r,compar,param);
}

void	V_GLOBAL
vpsSort(vp_stack_t *pointers,int (V_CALL *compar)(void*,void*,void*),void *param)
{
	vpsSort_r(vpsGetStorage(pointers),0,vpsCount(pointers)-1,
		compar,param);
}
*/
#define MAX 4 * 1024 * 1024
int data[MAX];

#include <stdlib.h>
#include <stdio.h>

#ifdef	_MSC_VER
extern unsigned __stdcall GetTickCount(void);
#elif	defined(__linux)
#include <sys/times.h>
unsigned GetTickCount(void)
{
	/* WRONG ! */
	struct tms tm;
	times(&tm);
	return tm.tms_utime+tm.tms_stime;
}
#endif

int main()
{
	int i;
	unsigned start,end;
	for( i=0; i < MAX; i++ )
		data[i]=rand();
	printf( "Now sorting %d random numbers...\n\r",MAX);
	start=GetTickCount();
	sort(data,MAX);
  	end=GetTickCount();
	printf( "%u milliseconds - sort();\n",end-start );
	for( i=0; i < MAX; i++ )
		data[i]=rand();
	printf( "Now sorting %d random numbers using RTL qsort() ...\n\r",MAX);
	start=GetTickCount();
	qsort(data,MAX,sizeof(int),comp);
  	end=GetTickCount();
	printf( "%u milliseconds - qsort().\n",end-start );
	return 0;
}
