/*<html><body bgcolor=#B4C4B0><font color=#000000><strong><pre>*/
#ifndef   V_COMM_H
#define   V_COMM_H

typedef		void  *comm_handle_t;

#ifdef __cplusplus
extern "C" {
#endif
	/*
	 *	Opens COM port.
	 *	Input:
	 *		comm	- port number (1, 2, etc.)
	 *		rate	- baud rate;
	 *		bytesize - number of bits in byte;
	 *		parity 	- parity control;
	 *		stopbits - number of stop bits.
	 *	Output:
	 *		COM handle or NULL.
	 */
	comm_handle_t	V_GLOBAL	commOpen(int comm,int rate,int bytesize,
		int parity,int stopbits);
	/*
	 *	Closes COM port.
	 */
	void			V_GLOBAL	commClose(comm_handle_t com);
	/*
	 *	Writes buffer to port.
	 */
	int				V_GLOBAL	commWrite(comm_handle_t comm,void *src,
		u32_t num_bytes);
	/*
	 *	Reads NumberOfBytes from port and stores it in InBuf.
	 */
	int				V_GLOBAL	commRead(comm_handle_t comm,void *dst,
		u32_t num_bytes);
	/*
	 *	Resets COMM port.
	 */
	void			V_GLOBAL	commReset(comm_handle_t comm);
#ifdef	__cplusplus
}
#endif	/* __cplusplus */

#endif	/* V_COMM_H */

/*</pre></body></html>*/
/*EOF*/
