/*<html><body bgcolor=#B4C4B0><font color=#000000><strong><pre>*/
#ifndef	V_FIFO_H
#define V_FIFO_H

/*	Byte queue.
*/
typedef struct	u8_fifo_s
{
	unsigned	size;
	unsigned	head;
	unsigned	tail;
	unsigned	avail;
	u8_t		*buf;
} u8_fifo_t, *u8_fifo_p;

/*	Block queue.
*/
typedef struct	fifo_s
{
	unsigned	element_size;
	unsigned	size;
	unsigned	avail;
	u8_t		*buf,*head,*tail,*limit;
} fifo_t, *fifo_p;

#ifdef	__cplusplus
extern "C" {
#endif	/* __cplusplus */
	/*
	 */
	void	V_GLOBAL	u8fInit(u8_fifo_t *fifo);
	void	V_GLOBAL	fifoInit(fifo_t *fifo,unsigned element_size);
	/*
	 */
	void	V_GLOBAL	u8fPush(u8_fifo_t *fifo,u8_t element);
	void	V_GLOBAL	fifoPush(fifo_t *fifo,void *element);
	/*
	 */
	void	V_GLOBAL	u8fPushBuffer(u8_fifo_t *fifo,u8_t *src,
		unsigned num_elements);
	/*
	 */
	int		V_GLOBAL	u8fPop(u8_fifo_t *fifo,u8_t *element);
	int		V_GLOBAL	fifoPop(fifo_t *fifo,void *element);
	/*
	 */
	int		V_GLOBAL	u8fPopBuffer(u8_fifo_t *fifo,u8_t *dst,
		unsigned num_elements);
	/*
	 */
	void	V_GLOBAL	u8fClear(u8_fifo_t *fifo);
	void	V_GLOBAL	fifoClear(fifo_t *fifo);
	/*
	 *	Discards contents of FIFO, but not affects size of buffer
	 *	(buffer is NOT free()'d).
	 */
	void	V_GLOBAL	u8fPurge(u8_fifo_t *fifo);
	void	V_GLOBAL	fifoPurge(fifo_t *fifo);
#ifndef	FIFO_NO_MACRO

#define	u8fCount(fifo)					((fifo)->size-(fifo)->avail)
#define	fifoCount(fifo)					((fifo)->size-(fifo)->avail)

#else	/* FIFO_NO_MACRO undefined */

	unsigned	V_GLOBAL	u8fCount(u8_fifo_t *fifo);
	unsigned	V_GLOBAL	fifoCount(fifo_t *fifo);

#endif

#ifdef	__cplusplus
}
#endif	/* __cplusplus */

#endif	/* V_FIFO_H */
/*</pre></body></html>*/
/*EOF*/
