/*<html><body bgcolor=#B4C4B0><font color=#000000><strong><pre>*/
#ifndef V_LIB_H
#define V_LIB_H

/*													  <font color=#FFFFFF>
 *	======================================================================
 *                         V library master header file
 *	======================================================================
 *
 *	Purpose:	Another one library that - or only should be ! - platform-
 *				independent. Currently about 50% of code compiles both 
 *				under NT (and under MustDie - if you prefer it) and Linux.
 *				But OS-specific APIs are still unwrapped; rest of code
 *				works only under NT. My guess, Linux is VERY GOOD;
 *				but NT is best.
 *
 *	Language:	ANSI C. We can write object-oriented code in C, arn't we ?
 *
 *	Author:		Vladimir A. Smirnov
 *
 *	Type of routines:	Vector algebra, OpenGL connectivity; abstaction
 *						layer for data reading (one set of function that
 *						performs reading both from disk and PAK files);
 *						image loading (and JPEGLIB connectivity); logging
 *						and console i/o; IPC channels (currently only 
 *						local channels implemented); general-purpose
 *						algorithms (stacks - growable arrays, fifo's);
 *						routines for vector graphics.
 *
 *	Project started:	Autumn, 1998.
 *	Last update: 		19.11.2000.
 *
 *	Copyright:			Copyrighted under GNU GPL.
 *	======================================================================
 */

/*
 *	These several lines are not mine. Stolen from MGL.
 */
#if defined(__M_ALPHA) || defined(ALPHA) || defined(__ALPHA) || \
	defined(__ALPHA__) || defined(__alpha)
#ifndef __ALPHA__
#define __ALPHA__
#endif	/* __ALPHA */
#elif defined(__M_PPC) || defined(__POWERC) || defined(PPC) || \
	defined(__PPC__)
#ifndef __PPC__
#define __PPC__
#endif	/* __PPC__ */
#elif defined(__M_MRX000) || defined(MIPS) || defined(__MIPS__)
#ifndef __MIPS__
#define __MIPS__
#endif	/* __MIPS */
#else
#ifndef __INTEL__
#define __INTEL__
#endif	/* __INTEL__ */
#endif	/* defined(__M_ALPHA) ... */
/*													<font color=#FFFFFF>
 *	Determine target platform.
 *													</font>*/
#if     defined(_WIN32) || defined(__WIN32__) || defined(WIN32) || \
		defined(_MSC_VER) || defined(__BORLANDC__)
#ifndef __WIN32__
#define __WIN32__
#endif
#elif   defined(__ELF__) || defined(__linux) || defined(unix) || \
		defined(UNIX)
#ifndef __UNIX__
#define __UNIX__
#endif
#else
#ifndef __DOS32__
#define __DOS32__
#endif
#endif
/*													  <font color=#FFFFFF>
 *	Determine default path style.
 *																 </font>*/
#if		!defined(__UNIX__) && !defined(__CYGWIN32__)

#define	OS_PATH_DELIMITER		'\\'
#if		defined(__BORLANDC__) || defined(__WATCOMC__)
#define	HAVE_DIRENT
#endif	/* defined(__BORLANDC__) || defined(__WATCOMC__) */

#else	/* We are working under right-slashed environment */
#define	RIGHT_SLASHED
#define	OS_PATH_DELIMITER		'/'
#define	HAVE_DIRENT
#endif	/* !defined(__UNIX__) && !defined(__CYGWIN32__) */

/*
 *	Include extra config information.
 */
#include	"v_conf.h"

/*													  <font color=#FFFFFF>
 *	Standart headers.
 *																 </font>*/
#include	<ctype.h>
#include	<stdio.h>
#include	<fcntl.h>
#include	<stdlib.h>
#include	<stdarg.h>
#include	<string.h>
#include	<malloc.h>

/*			'math.h' from VisialC 5.0 is ANSI- and C++ - uncompliant */
#ifdef		_MSC_VER
#pragma 	warning(disable:4001)	/* C++ - style comment */
#pragma 	warning(disable:4146)	/* unary minus applied to unsigned */
#pragma 	warning(disable:4514)	/* unreferenced inline func removed */
#endif		/* _MSC_VER */

#include	<math.h>

#ifdef		_MSC_VER
#pragma 	warning(default:4001)
#endif		/* _MSC_VER */

#if			defined(__DOS32__) || defined(__BORLANDC__)
#include	<dos.h>
#endif		/* defined(__DOS32__) || defined(__BORLANDC__) */

#ifdef		__UNIX__
#include	<sys/io.h>
#include	<sys/types.h>
#include 	<sys/stat.h>
#include	<dirent.h>
#include	<unistd.h>
#else		/* __UNIX__ */
#ifdef		__CYGWIN32__
#include	<unistd.h>
#endif		/* __CYGWIN32__ */
#include	<io.h>
#include 	<sys/stat.h>
#include	<direct.h>

#if			defined(HAVE_DIRENT) && !defined(__WATCOMC__)
#include	<dirent.h>
#endif		/* defined(HAVE_DIRENT) && !defined(__WATCOMC__) */

#endif		/* __UNIX__ */

#ifndef		_MAX_DRIVE
#ifndef		MAX_DRIVE
#define		_MAX_DRIVE		4
#else		/* MAX_DRIVE */
#define		_MAX_DRIVE		MAX_DRIVE
#endif		/* MAX_DRIVE */
#endif		/* _MAX_DRIVE */

#ifndef		_MAX_PATH
#ifndef		MAX_PATH
#define		_MAX_PATH		256
#else		/* MAX_PATH */
#define		_MAX_PATH		MAX_PATH
#endif		/* MAX_PATH */
#endif		/* _MAX_PATH */

#ifndef		_MAX_DIR
#ifndef		MAX_DIR
#define		_MAX_DIR		256
#else		/* MAX_DIR */
#define		_MAX_DIR		MAX_DIR
#endif		/* MAX_DIR */
#endif		/* _MAX_DIR */

#ifndef		_MAX_FNAME
#ifndef		MAX_FNAME
#define		_MAX_FNAME		256
#else		/* MAX_FNAME */
#define		_MAX_FNAME		MAX_FNAME
#endif		/* MAX_FNAME */
#endif		/* _MAX_FNAME */

#ifndef		_MAX_EXT
#ifndef		MAX_EXT
#define		_MAX_EXT		256
#else		/* MAX_EXT */
#define		_MAX_EXT		MAX_EXT
#endif		/* MAX_EXT */
#endif		/* _MAX_EXT */

#ifdef		DEBUG
#include	<assert.h>
#define		V_ASSERT(exp)		assert(exp)
#else		/* DEBUG */
#define		V_ASSERT(exp)
#endif		/* DEBUG */

/*													  <font color=#FFFFFF>
 *	Default calling convention
 *																 </font>*/
#if			!defined(__GNUC__)
#define		V_CALL				__stdcall
#else		/* __UNIX__ */
#define		V_CALL
#endif		/* __UNIX__ */

/*													  <font color=#FFFFFF>
 *	Modifier for functions exporting from *.dll and *.so
 *																 </font>*/
#ifdef		BUILD_DLL
#define		EXPORT				__declspec(dllexport)
#else		/* BUILD_DLL */
#define		EXPORT
#endif		/* BUILD_DLL */

#define		V_LOCAL			static
#define		V_GLOBAL		EXPORT	V_CALL

#if			defined(BCB_COMPAT) || defined(__BORLANDC__)
#define		V_GLOBAL_VA		EXPORT	__cdecl
#else		/* !BCB_COMPAT */
#define		V_GLOBAL_VA		V_GLOBAL
#endif		/* BCB_COMPAT */

/*
 *			Is this really needed - ?
 */
#ifdef		__INTEL__

#define		LittleLong(n)   (n)
#define		LittleShort(n)  (n)

#else		/* __INTEL__ */

#error This library is not tested on RISC platforms !

#define		LittleLong(n)\
			((((n)<<24)&0xFF000000)|(((n)<<8)&0xFF0000)|\
			(((n)>>8)&0xFF00)|(((n)>>24)&0xFF))
#define 	LittleShort(n)\
			((((n)<<8)&0xFF00)|(((n)>>8)&0xFF))

#endif	/* __INTEL__ */

/*													  <font color=#FFFFFF>
 *	Extra stuff for Win32
 *																 </font>*/
#if     defined(__WIN32__) && defined(BUILD_DLL) && !defined(SINGLETHREADED)
/*		Isolate threads */
#ifndef	MULTITHREADED
#define MULTITHREADED
#endif	/*  MULTITHREADED */
#endif	/* defined(BUILD_DLL) && !defined(SINGLETHREADED) */

#include	"v_types.h"

#define memAlloc					libvMalloc
#define memFree						libvFree

#ifdef	__cplusplus
extern "C" {
#endif	/* __cplusplus */
	/*
	 *	Allocates in frees memory using general memory management
	 *	functions which are used inside libV.
	 *	Implemented in v_mt.c.
	 */
	void_p	V_GLOBAL	libvMalloc(u32_t size);
	void	V_GLOBAL	libvFree(void *block);
	/*	These functions must be called once per each thread (including
	 *	main thread) if LibV linked statically.
	 *	Implemented in v_mt.c.
	 */
#ifdef	MULTITHREADED

	vboolean	V_CALL		libvPerThreadInit(void);
	vboolean	V_CALL		libvPerThreadShutdown(void);

#endif	/* MULTITHREADED */

#ifdef	__cplusplus
}
#endif	/* __cplusplus */

/*
 *		Workaround for BCB linker.
 */
#if		defined(BUILD_DLL) && defined(BCB_COMPAT) && !defined(__BORLANDC__)
#define	conPrintf	_conPrintf
#define	conlPrintf	_conlPrintf
#define	filePrintf	_filePrintf
#define	glPrintf	_glPrintf
#endif

/*													  <font color=#FFFFFF>
 *	Other headers.
 *											 </font><font color=#80FFFF>*/
#include	"v_x86.h"
#include	"v_btree.h"
#include	"v_math.h"
#include	"v_vector.h"
#include	"v_gpsp.h"
#include	"v_log.h"
#include	"v_matrix.h"
#include	"v_plane.h"
#include	"v_space.h"
#include	"v_time.h"
#include	"v_fifo.h"
#include	"v_parse.h"
#include	"v_objlib.h"
#include	"v_pgrid.h"
#include	"v_pprof.h"
#include	"v_fs.h"
#include	"v_image.h"
#include	"v_str.h"
#include	"v_stack.h"
#include	"v_ipc.h"
#include	"v_comm.h"
#include	"v_wmf.h"
#include	"v_input.h"
#include	"sgi/gl.h"
#include	"v_camctl.h"
#include	"v_gl.h"
#include	"v_tlist.h"
#include	"v_incon.h"
#include	"v_fbdraw.h"
#include	"v_sched.h"
#include	"v_wavlib.h"

#ifdef		__WATCOMC__
/*			HACK */
#define		strcmpi		strcmp
#endif		/* __WATCOMC__ */

#ifndef		_MSC_VER
#define		_stricmp	strcmpi
#define		_chdir		chdir
#define 	_mkdir      mkdir
#define		_getcwd		getcwd
#endif		/* _MSC_VER */

#if			!defined(__UNIX__) && !defined(__GNUC__)
#define		strcasecmp		_stricmp
#define		strncasecmp		_strnicmp
#endif		/* !defined(__UNIX__) */

/*</font>*/

#endif		/* V_LIB_H */
/*</pre></strong></body></html>*/
/*EOF*/
