/*<html><body bgcolor=#B4C4B0><font color=#000000><strong><pre>*/
#ifndef	V_SCHED_H
#define V_SCHED_H

typedef	void	(V_CALL	*thread_proc_t)(void *arg);
typedef void	*thread_t;
typedef void	*mutex_t;
typedef void	*cond_t;

#ifdef	__cplusplus
extern "C" {
#endif	/* __cplusplus */
	/*	Thread API ==================================================== */
	/*	Caller - side */
	thread_t	V_GLOBAL	threadCreate(thread_proc_t start_address,
		void *arg);
	/*	Waits for thread termination */
	vboolean	V_GLOBAL	threadJoin(thread_t thread,u32_t *exit_code);
	/*	Thread - side (call is NOT necessary; if thread routine returns, 
	 *	zero exit code assumed) */
	void		V_GLOBAL	threadExit(u32_t exit_code);
    /*	TSD key management */
    u32_t		V_GLOBAL	threadCreateKey(void);
    void		V_GLOBAL	threadDestroyKey(u32_t key);
    /*	TSD management */
	void		V_GLOBAL	threadSetSpecific(u32_t key,void_p specific);
	void_p		V_GLOBAL	threadGetSpecific(u32_t key);
	/*	Mutex API ===================================================== */
	/*	Creates new mutex */
	mutex_t		V_GLOBAL	mutexCreate();
	/*	Aquires mutex (warning: BLOCKING call !) */
	void		V_GLOBAL	mutexLock(mutex_t mutex);
	/*	Returns 'true' if mutex is aquired, otherwise immidiately 
	 *	returns 'false' */
	vboolean	V_GLOBAL	mutexTryLock(mutex_t mutex);
	/*	Relases mutex */
	void		V_GLOBAL	mutexUnlock(mutex_t mutex);
	/*	Destroys mutex object */
	void		V_GLOBAL	mutexDestroy(mutex_t mutex);
	/*	Conditional variables API ===================================== */
	/*	Creates new condvar; if 'autoreset' == false than condvar must be
	 *	reset explicitly before condWait() */
	cond_t		V_GLOBAL	condCreate(vboolean autoreset);
	/*	Sets manual-reset condvar to TRUE and releases all waiting 
	 *	threads. */
	vboolean	V_GLOBAL	condSet(cond_t cond);
	/*	Sets condvar to FALSE. Does nothing for autoreset condvar. */
	vboolean	V_GLOBAL	condReset(cond_t cond);
	/*	Releases all waiting threads, but doesn't sets condvar to TRUE;
	 *	in case of autoreset condvar, same as condSet(). */
	vboolean	V_GLOBAL	condPulse(cond_t cond);
	/*	Blocks until condvar set to TRUE */
	vboolean	V_GLOBAL	condWait(cond_t cond);
	/*	Blocks until condvar set to TRUE or timeout reached; in case
	 *	of error / timeout returns false. */
	vboolean	V_GLOBAL	condTimedWait(cond_t cond,u32_t milliseconds);
	/*	Destroys conditional variable */
	void		V_GLOBAL	condDestroy(cond_t cond);
#ifdef	__cplusplus
}
#endif	/* __cplusplus */

#endif	/* V_SCHED_H */
/*</pre></strong></body></html>*/
/*EOF*/
