/*<html><body bgcolor=#B4C4B0><font color=#000000><strong><pre>*/
#ifndef V_X86_H
#define V_X86_H

#define	memZero						v_zero
#define	memCopy						v_copy
#define	memSet						v_fill

#if		!defined(__INTEL__) || defined(__UNIX__) || defined(__CYGWIN32__)
#define	__NOX86__
#endif	/* !defined(__INTEL__) ... */

#ifdef	__NOX86__

#define	v_fill(dest,value,length)	memset(dest,value,length)
#define	v_zero(dest,length)			memset(dest,0,length)
#define	v_copy(dest,src,length)		memcpy(dest,src,length)
#define	v_filldw(dest,value,dwords)	memset(dest,value,(dwords)<<2)
#define	v_zerodw(dest,dwords)		memset(dest,0,(dwords)<<2)
#define	v_copydw(dest,src,dwords)	memcpy(dest,src,(dwords)<<2)
#define	v_abs(x)					fabs(x)
#define	v_fsincos(s,c,r)			*((vec_t*)s)=sin(r);*((vec_t*)c)=cos(r)

#else     /* __NOX86__ */

#ifdef		__WATCOMC__

void        v_fill( void *dest, unsigned char value, unsigned long length);
#pragma aux v_fill = \
	"mov ah, al"\
	"mov ecx, eax"\
	"shl eax, 16"\
	"mov ax, cx"\
	"mov ecx, edx"\
	"shr ecx, 2"\
	"rep stosd"\
	"mov ecx, edx"\
	"and ecx, 3"\
	"rep stosb"\
	parm [EDI] [AL] [EDX] modify [EAX ECX EDI];

void        v_zero(void *dest, unsigned long length);
#pragma aux v_zero = \
	"xor eax, eax"\
	"mov ecx, edx"\
	"shr ecx, 2"\
	"rep stosd"\
	"mov ecx, edx"\
	"and ecx, 3"\
	"rep stosb"\
	parm [EDI] [AL] [EDX] modify [EAX ECX EDI];

void        v_copy( void *dest, void *src, unsigned long length );
#pragma aux v_copy = \
	"mov ecx, eax"\
	"shr ecx, 2"\
	"rep movsd"\
	"mov ecx, eax"\
	"and ecx, 3"\
	"rep movsb"\
	parm [EDI] [ESI] [EAX] modify [ECX ESI EDI];

void        v_filldw(void *dest,unsigned char value,unsigned long dwords);
#pragma aux v_filldw = \
	"mov ah, al"\
	"mov edx, eax"\
	"shl eax, 16"\
	"mov ax, dx"\
	"rep stosd"\
	parm[EDI] [AL] [ECX] modify [EAX EDX ECX EDI];

void        v_zerodw(void *dest,unsigned long dwords);
#pragma aux v_zerodw= \
	"xor eax, eax"\
	"rep stosd"\
	parm[EDI] [ECX] modify [EAX ECX EDI];

void        v_copydw(void *dest, void *src, unsigned long dwords);
#pragma aux v_copydw= \
	"rep movsd"\
	parm[EDI] [ESI] [ECX] modify[EDI ESI ECX];

#else /* __WATCOMC__ */

#ifdef	__cplusplus
extern "C" {
#endif /* __cplusplus */
	void	V_GLOBAL	v_fill(void *dest, unsigned char value, unsigned int _length);
	void	V_GLOBAL	v_zero(void *dest, unsigned int _length);
	void	V_GLOBAL	v_copy(void *dest, void *src, unsigned int _length);
	void	V_GLOBAL	v_filldw(void *dest,unsigned char value, unsigned int _dwords);
	void	V_GLOBAL	v_zerodw(void *dest, unsigned int _dwords);
	void	V_GLOBAL	v_copydw(void *dest, void *src, unsigned int _dwords);
#ifdef	__cplusplus
}
#endif /* __cplusplus */

#endif /* __WATCOMC__ */

#ifdef	__cplusplus
extern "C" {
#endif	/* __cplusplus */
	float	V_GLOBAL	v_abs_f(float x);
	void	V_GLOBAL	v_fsincos_f(float *s,float *c,float radians);
	void	V_GLOBAL	v_fsincos_d(double *s,double *c,double radians);
#ifdef	__cplusplus
}
#endif	/* __cplusplus */

#ifndef DOUBLEVEC
#define v_abs(x)          v_abs_f(x)
#define v_fsincos(s,c,r)  v_fsincos_f(s,c,r)
#else	/* DOUBLEVEC */
#define v_abs(x)          fabs(x)
#define v_fsincos(s,c,r)  v_fsincos_d(s,c,r)
#endif  /* DOUBLEVEC */

#endif /* __NOX86__ */

#endif /* V_X86_H */
/*</pre></strong></body></html>*/
/*EOF*/
