unit Remap;

interface

uses
	LibV;
    
type
	TRemap			= class
    private
    	Size		:	u32_t;
        IBase		:	u32_t;
        FBase		:	u32_t;
        FMap		:	u32_t_array_p;
        function	GetMap(Ind:u32_t):integer;
        procedure	SetMap(Ind,Map:u32_t);
    public
    	constructor	Create(Size,IBase,FBase:u32_t);
        destructor	Destroy;override;
        procedure	Free;
        property	Map[Ind:u32_t] : u32_t read GetMap write SetMap;
    end;


implementation

uses
	Dialogs;
    
constructor	TRemap.Create(Size,IBase,FBase:u32_t);
var
	i : u32_t;
begin
	Self.Size:=Size;
	Self.FBase:=FBase;
    Self.IBase:=IBase;
	GetMem(FMap,Size*sizeof(u32_t));
    i:=0;
    while i<Size do
    begin
    	FMap^[i]:=i;
    	i:=i+1;
    end;
end;

destructor	TRemap.Destroy;
begin
	FreeMem(FMap);
    inherited Destroy;
end;

procedure	TRemap.Free;
begin
	if Self <> nil then
    	Destroy;
end;

function	TRemap.GetMap(Ind:u32_t):integer;
begin
	Assert((Ind-IBase)<Size);
    Result:=FBase+FMap[Ind-IBase];
end;

procedure	TRemap.SetMap(Ind,Map:u32_t);
var
	Ofs : u32_t;
    Old : u32_t;
begin
	Ind:=Ind-IBase;
    Map:=Map-FBase;
	Assert(Ind<Size);
	Assert(Map<Size);
	(* find current offset for 'Map' *)
	Ofs:=0;
    while Ofs<Size do
    begin
    	if FMap[Ofs]=Map then
        	break;
    	Ofs:=Ofs+1;
    end;
	if Ofs=Size then
    begin
    	ShowMessageFmt('Can''t find offset for %u',[Map]);
        Exit;
    end;
    (* Swap values *)
    Old:=FMap[Ind];
    FMap[Ind]:=Map;
    FMap[Ofs]:=Old;
end;

end.
