#include <v_lib.h>

int	main(int argc, char *argv[])
{
	comm_handle_t comm;
	ipc_handle_t con;
	char buf[16];
	
	ipcInit();
	logStartConsoleLog();
	logUpperLevel(LOG_TRACE);
	incStartServer("input_srv");
	con=ipcClientEndpoint("input_srv");

	if(argc>1)
		comm=commOpen(2,atoi(argv[1]),8,0,0);
	else
		comm=commOpen(2,9600,8,0,0);
		
	if(!comm)
		return -1;
	/*
	buf[0]=16;
	if(!commWrite(com,buf,1,))
		return -1;
	*/
	printf("Reading bytes from COM2 (press eny key and wait for 16* to exit)\n");
	for(;;)
	{
		int i;
		for(i=0;i<16;i++)
			if(!commRead(comm,buf,16))
			{
				puts("commRead() failed; re-opening port ...");
				commClose(comm);
				if(argc>1)
					comm=commOpen(2,atoi(argv[1]),8,0,0);
				else
					comm=commOpen(2,9600,8,0,0);
			}
			else
				printf("*");
			puts("");
		for(i=0;i<15;i++)
			printf("%d\t",buf[i]);
		printf("%d\n",buf[i]);
		if(ipcRecvCount(con))
		{
			commClose(comm);
			ipcClose(con);
			incStopServer();
			return 0;
		}
	}
	return 0;
}

/*
static void
commDumpTimeouts(COMMTIMEOUTS *timeouts)
{
	conlPrintf(LOG_TRACE,
		"ReadIntervalTimeout		%d\n"
		"ReadTotalTimeoutMultiplier	%d\n"
		"ReadTotalTimeoutConstant	%d\n"
		"WriteTotalTimeoutMultiplier	%d\n"
		"WriteTotalTimeoutConstant		%d\n",
		timeouts->ReadIntervalTimeout,
		timeouts->ReadTotalTimeoutMultiplier,
		timeouts->ReadTotalTimeoutConstant,
		timeouts->WriteTotalTimeoutMultiplier,
		timeouts->WriteTotalTimeoutConstant);
}

static void
commDumpDCB(DCB *dcb)
{
	conlPrintf(LOG_TRACE,
		"BaudRate		%d\n"
		"fBinary		%d\n"
		"fParity		%d\n"
		"fOutxCtsFlow	%d\n"
		"fOutxDsrFlow	%d\n"
		"fDtrControl	%d\n"
		"fDsrSensitivity	%d\n"
		"fTXContinueOnXoff	%d\n"
		"fOutX			%d\n"
		"fInX			%d\n"
		"fErrorChar		%d\n"
		"fNull			%d\n"
		"fRtsControl	%d\n"
		"fAbortOnError	%d\n"
		"XonLim			%d\n"
		"XoffLim		%d\n"
		"ByteSize		%d\n"
		"Parity			%d\n"
		"StopBits		%d\n"
		"XonChar		%d\n"
		"XoffChar		%d\n"
		"ErrorChar		%d\n"
		"EofChar		%d\n"
		"EvtChar		%d\n",
		dcb->BaudRate,
		dcb->fBinary,
		dcb->fParity,
		dcb->fOutxCtsFlow,
		dcb->fOutxDsrFlow,
		dcb->fDtrControl,
		dcb->fDsrSensitivity,
		dcb->fTXContinueOnXoff,
		dcb->fOutX,
		dcb->fInX,
		dcb->fErrorChar,
		dcb->fNull,
		dcb->fRtsControl,
		dcb->fAbortOnError,
		dcb->XonLim,
		dcb->XoffLim,
		dcb->ByteSize,
		dcb->Parity,
		dcb->StopBits,
		dcb->XonChar,
		dcb->XoffChar,
		dcb->ErrorChar,
		dcb->EofChar,
		dcb->EvtChar);
}
*/