#include <v_lib.h>

void	V_CALL	draw_string(void *param)
{
	gl_outline_font_t *fnt=(gl_outline_font_t *)param;
	glClearColor(1,1,1,1);
	glClear(GL_COLOR_BUFFER_BIT);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glFrustum(-1,1,-1,1,2,100);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glColor3f(1,0,0);
	vglSelectFont(fnt);
	glTranslatef(0,0,-10);
	vglPrintf(" !!!");
	vglSwapBuffers();
}

int main()
{
	gl_outline_font_t *fnt;
	void *pixbuf;
	u32_t w,h;
	glw_t out;
	logStartConsoleLog();
	logStartFileLog("app.log",true);
	logUpperLevel(LOG_TRACE);
	out=vglCreateOffscreenWindow(381,381);
	/* we must do it after OpenGL ctx creation */
	fnt=vglCreateFont("Arial",false,0,NULL);
	draw_string(fnt);
	pixbuf=vglReadPixels(&w,&h);
	bmpSave("out.bmp",w,h,pixbuf);
	free(pixbuf);
	vglDrawToMetafile("out.wmf",100,100,draw_string,(void*)fnt);
	vglDeleteFont(fnt);
	vglDestroyWindow(vglGetCurrentWindow());
	printf("vglIterateWindows(): %d windows present\n",vglIterateWindows(NULL));
	return 0;
}
