#include <stdio.h>
#include <v_lib.h>

void dump_event(input_record_t *ev)
{
	printf("%d: %d, %d\n",ev->event,ev->first_code,ev->second_code);
}

int main()
{
	ipc_handle_t cl;
	char buf[128];
	input_record_t in;

	logStartConsoleLog();
	logUpperLevel(LOG_TRACE);
	
	ipcInit();
	
	if(!incStartServer(NULL)) {
		puts("Can't start console input server.");
		return -1;
	}
	
	timeDelay(100);
	
	cl=ipcClientEndpoint("ConsoleInput");
	
	do
	{
		inGetEvent(cl,&in,true);
		inMakeString(buf,&in,128);
		puts(buf);
	}	while(in.second_code!=27);
	
	ipcClose(cl);
	incStopServer();
	ipcShutdown();
	return 0;
}
