#include	<windows.h>
#include	<v_lib.h>

void ipc_srv_puts(ipc_handle_t s,int cl_id,int broadcast,char *buf)
{
	int len=strlen(buf);
	buf[len]=0x0A;
	if(broadcast)
		ipcSend(s,buf,len+1);
	else
		ipcSendTo(s,cl_id,buf,len+1);
	buf[len]=0;
}

LRESULT CALLBACK trd2(LPVOID arg)
{
	u32_t len;
	char buf[256];
	ipc_handle_t c;
	
	puts("Connecting to 'PrivateChannel'...");
	
	c=ipcClientEndpoint("PrivateChannel");
	if(!c)
	{
		puts("ipcClientEndpoint() !");
		ExitThread(0);
	}

	for(;;)
	{
		ipcWait(c,INFINITE);
		ipcGets(c,buf,256);
		if(!strcmp(buf,"term"))
		{
			printf("Thread [%d]: received TERM sig.\n",GetCurrentThreadId());
			ipcClose(c);
			ExitThread(0);
		}
		else if(!memcmp(buf,"echo",4))
		{
			char *ptr=buf+4;
			char echobuf[256];
			while(*ptr==32)
				ptr++;
			printf("Thread [%d]: echo '%s'\n",GetCurrentThreadId(),ptr);
			sprintf(echobuf,"[%d]:'%s'",GetCurrentThreadId(),ptr);
			ipcSend(c,echobuf,strlen(echobuf)+1);
		}
		else
			printf("Thread [%d]: received '%s'\n",GetCurrentThreadId(),buf);
	}
	return 0;
}

void V_CALL on_connect(ipc_handle_t ipch,u32_t cl)
{
	char buf[_MAX_PATH];
	ipcGetServerName(ipch,buf);
	printf("Client %d connected to %s.\n",cl,buf);
}

void V_CALL on_disconnect(ipc_handle_t ipch,u32_t cl)
{
	char buf[_MAX_PATH];
	ipcGetServerName(ipch,buf);
	printf("Client %d disconnected from %s.\n",cl,buf);
}

int main()
{
	ipc_handle_t s;
	u32_t cl_id=0;
	int broadcast=0;
	
	HANDLE th;
	DWORD tid;
	
	logStartConsoleLog();
	logUpperLevel(LOG_TRACE);
	
	puts("ipcInit() ...");
	ipcInit();

	puts("ipcServerEndpoint() ...");
	s=ipcServerEndpoint("PrivateChannel");
	
	if(!s)
	{
		puts("ipcServerEndpoint() !");
		ipcShutdown();
		return 0;
	}
	
	ipcConnectCallback(s,on_connect);
	ipcDisconnectCallback(s,on_disconnect);
	
	for(;;)
	{
		char buf[256];
		u32_t rc;
		Sleep(10);
		rc=ipcRecvCount(s);
		if(rc>256)
			rc=256;
		if(rc)
		{
			if(!ipcRecv(s,buf,rc))
			{
				puts("BUG");
				ExitProcess(0);
			}
			for(rc-=2;rc>0;rc--)
				if(!buf[rc])
					buf[rc]=';';
			printf("Server RECV: {%s}\n",buf);
			continue;
		}
		fgets(buf,256,stdin);
		strStripLT(buf);
		if(!strcmp(buf,"quit"))
			break;
		else if(!strcmp(buf,"run"))
		{
			th=CreateThread(NULL,0,trd2,NULL,0,&tid);
			if(WaitForSingleObject(th,100)==WAIT_OBJECT_0)
				puts("Thread died !");
		}
		else if(!memcmp(buf,"cl_",3))
		{
			sscanf(buf+3,"%d",&cl_id);
			printf("current client: %d\n",cl_id);
		}
		else if(!strcmp(buf,"broadcast"))
		{
			broadcast=!broadcast;
			printf("Broadcast mode: %d\n",broadcast);
		}
		else
		{
			ipc_srv_puts(s,cl_id,broadcast,buf);
		}
	}

	ipcClose(s);
	ipcShutdown();
	return 0;
}
