#	=======================================================================
cc=nice -10 gcc
ar=ar rc
mv=mv
rm=rm -f
target=libv
libdir=../arch/unix_a
cflags=-c -Wall -D__UNIX__
cdebug=-ggdb
self=unix_gcc.mak
#	=======================================================================
all:
	make -f $(self) lib
	make -f $(self) install
#	make -f $(self) clean
#	=======================================================================
objfiles=v_fifo.o v_fs.o v_log.o v_math.o v_matrix.o \
	v_objlib.o v_parse.o v_pgrid.o v_pprof.o v_plane.o \
	v_space.o v_stack.o v_str.o v_vector.o v_image.o \
	v_time.o v_camctl.o v_tlist.o v_mt.o v_gpsp.o \
	v_sched.o v_input.o v_glx.o v_btree.o v_wavlib.o
#	=======================================================================
libdjpeg=../../jpeg-6b-src/libjpeg
jdobjfiles=jdapimin.o jdapistd.o jdtrans.o jdatasrc.o \
	jdmaster.o jdinput.o jdmarker.o jdhuff.o jdphuff.o \
	jdmainct.o jdcoefct.o jdpostct.o jddctmgr.o jidctfst.o \
	jidctflt.o jidctint.o jidctred.o jdsample.o jdcolor.o \
	jquant1.o jquant2.o jdmerge.o jcomapi.o jutils.o \
	jerror.o jmemmgr.o jmemnobs.o
$(jdobjfiles):
	ar -x $(libdjpeg)a $(jdobjfiles)
#	=======================================================================
srcfiles=$(objfiles:.o=.c)
lib:$(target)a
libobjects=$(objfiles) $(jdobjfiles)
# libobjects=$(objfiles)
$(target)a: $(libobjects)
	$(ar) $(target)a $(libobjects)
.c.o:
	$(cc) $(cflags) $*.c
v_glx.o:unix/v_glx.c
	$(cc) $(cflags) unix/v_glx.c
install:
	$(rm) $(libdir)/$(target)a
	$(mv) $(target)a $(libdir)/$(target)a
clean:
	$(rm) $(objfiles)
	$(rm) $(jdobjfiles)
