/*<html><body bgcolor=#000080><font color=#C0C0B0><strong><pre>*/
#include	"../include/v_lib.h"
#include	"../source/v_mt.h"
#include	"v_os.h"

#if			defined(__WIN32__)

#if			0

typedef struct  comm_params_s
{
	char          ComName[32];
	int           ComNum;
	HANDLE        idCom;
	OVERLAPPED    osWrite,osRead;
	DWORD         dwBytesReaden;
	DWORD         dwBytesWritten;
	COMMTIMEOUTS  CommTimeOuts;
}	comm_params_t, *comm_params_p;

int		V_LOCAL
commSetupConnection(comm_params_p com,int rate,int bytesize,
	int parity,int stopbits)
{
	DCB Dcb;
	memset(&Dcb,0,sizeof(DCB));
	Dcb.DCBlength=sizeof(DCB);
	GetCommState(com->idCom,&Dcb) ;
	Dcb.BaudRate=rate; // CBR_9600;
	Dcb.ByteSize=(unsigned char)bytesize; // 8;
	Dcb.Parity=(unsigned char)parity; //NOPARITY;
	Dcb.StopBits=(unsigned char)stopbits; //ONESTOPBIT;
	Dcb.fDtrControl=DTR_CONTROL_DISABLE;
	Dcb.fRtsControl=RTS_CONTROL_DISABLE;
	Dcb.fBinary=1;
	Dcb.fParity=(parity == NOPARITY) ? 0 : 1;
	return SetCommState(com->idCom,&Dcb) ? 1 : 0;
}

void	V_LOCAL
commSetTimeouts(comm_params_p com)
{
	if(WeAreUnderMustDie())
		com->CommTimeOuts.ReadIntervalTimeout = 10000;
	else
		com->CommTimeOuts.ReadIntervalTimeout = 0;
	com->CommTimeOuts.ReadTotalTimeoutMultiplier = 0;
	com->CommTimeOuts.ReadTotalTimeoutConstant = 0;
	com->CommTimeOuts.WriteTotalTimeoutMultiplier = 0;
	com->CommTimeOuts.WriteTotalTimeoutConstant = 0;
	SetCommTimeouts(com->idCom,&com->CommTimeOuts);
}

comm_handle_t V_GLOBAL
commOpen(int comm,int rate,int bytesize,int parity,int stopbits)
{
	comm_params_p res;
	if(comm<0 || comm>4) return NULL;
	res=(comm_params_p)malloc(sizeof(comm_params_t));
	memset(res,0,sizeof(comm_params_t));
	res->ComNum=comm;
	sprintf(res->ComName,"COM%1d",res->ComNum);
	if((res->idCom=CreateFile(res->ComName,GENERIC_READ|GENERIC_WRITE,
		0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL|FILE_FLAG_OVERLAPPED,
		NULL))==INVALID_HANDLE_VALUE)
	{
		conlPrintf(LOG_ERROR,"CreateFile() failed.\n");
		free(res);
		return NULL;
	}
	if(!commSetupConnection(res,rate,bytesize,parity,stopbits))
	{
		conlPrintf(LOG_ERROR,"commSetupConnection() failed.\n");
		commClose(res);
		return NULL;
	}
	SetupComm(res->idCom,1024,1024);
	commReset((comm_handle_t)res);
	commSetTimeouts(res);
	return (comm_handle_t)res;
}

void	V_GLOBAL
commReset(comm_handle_t comm)
{
	PurgeComm(((comm_params_p)comm)->idCom,
		PURGE_TXABORT|PURGE_RXABORT|PURGE_TXCLEAR|PURGE_RXCLEAR);
}

void	V_GLOBAL
commClose(comm_handle_t comm)
{
	if(!comm) return;
	CloseHandle(((comm_params_p)comm)->idCom);
	free(comm);
}

int	V_GLOBAL
commWrite(comm_handle_t comm,void *OutBuf,int NumberOfBytes)
{
	DWORD dwError;
	comm_params_p com=(comm_params_p)comm;
	if(!comm || !OutBuf || NumberOfBytes<1)
	{
		com->dwBytesWritten = 0;
		return 0;
	}
	if(!WriteFile(com->idCom,OutBuf,NumberOfBytes,&com->dwBytesWritten,&com->osWrite))
	{
		dwError=GetLastError();
		if(dwError==ERROR_IO_PENDING)
		{
			WaitForSingleObject(com->idCom,10000);
			if(!GetOverlappedResult(com->idCom,&com->osWrite,&com->dwBytesWritten,0))
			{
				com->dwBytesWritten = 0;
				return 0;
			}
		}
		else
		{
			com->dwBytesWritten = 0;
			return 0;
		}
	}
	return (int)com->dwBytesWritten;
}

int		V_GLOBAL
commRead(comm_handle_t comm,void *InBuf,int NumberOfBytes)
{
	DWORD dwError;
	comm_params_p com=(comm_params_p)comm;
	if(!comm || !InBuf || NumberOfBytes<1)
	{
		com->dwBytesReaden = 0;
		return 0;
	}
	if(!ReadFile(com->idCom,InBuf,NumberOfBytes,&com->dwBytesReaden,&com->osRead))
	{
		dwError=GetLastError();
		if(dwError==ERROR_IO_PENDING)
		{
			WaitForSingleObject(com->idCom,10000);
			if(!GetOverlappedResult(com->idCom,&com->osRead,&com->dwBytesReaden,0))
			{
				com->dwBytesReaden = 0;
				return 0;
			}
		}
		else
		{
			com->dwBytesReaden = 0;
			return 0;
		}
	}
	return (int)com->dwBytesReaden;
}

#else

#define	COMM_MAGIC		0xC04D504F

typedef struct	comm_port_s
{
	u32_t		magic;
	char		port_name[_MAX_PATH];
	HANDLE		port;
	HANDLE		cancel_io;
}	comm_port_t, *comm_port_p;

comm_port_p	V_LOCAL
comm_port_create(HANDLE port,char *port_name)
{
	comm_port_p	ret;
	ret=(comm_port_p)malloc(sizeof(comm_port_t));
	v_zero(ret,sizeof(comm_port_t));
	ret->magic=COMM_MAGIC;
	strCopy(ret->port_name,port_name,_MAX_PATH);
	ret->port=port;
	ret->cancel_io=CreateEvent(NULL,TRUE,FALSE,NULL);
	return ret;
}

void	V_LOCAL
comm_port_destroy(comm_port_t *comm_port)
{
	if(!comm_port)
		return;
	CloseHandle(comm_port->cancel_io);
	free(comm_port);
}
	
/*
 *	commOpen()
 */
comm_handle_t	V_GLOBAL
commOpen(int port,int rate,int bytesize,int parity,int stopbits)
{
	HANDLE	com;
	char	port_name[_MAX_PATH];
	DCB		dcb;
	COMMTIMEOUTS	timeouts;
	sprintf(port_name,"COM%1d",port);
	com=CreateFile(port_name,
		GENERIC_READ|GENERIC_WRITE,
		0,
		NULL,
		OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL,
		NULL);
	if(!com)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,
			"commOpen(%d,%d,%d,%d,%d): CreateFile() failed (code %d)\n",
			port,rate,bytesize,parity,stopbits,GetLastError());
#endif	/* CHECKED_BUILD */
		return NULL;
	}
	ZeroMemory(&timeouts,sizeof(COMMTIMEOUTS));
	/* Minimal baud rate is 110 baud: 73 ms interval between bytes */
	timeouts.ReadTotalTimeoutMultiplier=73;
	if(!SetCommTimeouts(com,&timeouts))
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,
			"commOpen(%d,%d,%d,%d,%d): SetCommTimeouts() failed "
			"(code %d)\n",port,rate,bytesize,parity,stopbits,
			GetLastError());
#endif	/* CHECKED_BUILD */
		CloseHandle(com);
		return NULL;
	}
	ZeroMemory(&dcb,sizeof(DCB));
	dcb.DCBlength=sizeof(DCB);
	if(!GetCommState(com,&dcb))
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,
			"commOpen(%d,%d,%d,%d,%d): GetCommState() failed (code %d)\n",
			port,rate,bytesize,parity,stopbits,GetLastError());
#endif	/* CHECKED_BUILD */
		CloseHandle(com);
		return NULL;
	}
	dcb.BaudRate=rate;
	dcb.fBinary=TRUE;
	dcb.fParity=parity ? TRUE : FALSE;
	dcb.fOutxCtsFlow=FALSE;
	dcb.fOutxDsrFlow=FALSE;
	dcb.fDtrControl=DTR_CONTROL_DISABLE;
	dcb.fDsrSensitivity=FALSE;
	dcb.fOutX=FALSE;
	dcb.fInX=FALSE;
	dcb.fNull=FALSE;
	dcb.fRtsControl=RTS_CONTROL_DISABLE;
	/* 07.07.00: can be set to FALSE prevent error 995 */
	dcb.fAbortOnError=TRUE;
	dcb.ByteSize=(unsigned char)bytesize;
	dcb.Parity=(unsigned char)(parity ? EVENPARITY : NOPARITY);
	dcb.StopBits=(unsigned char)stopbits;
	if(!SetCommState(com,&dcb))
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,
			"commOpen(%d,%d,%d,%d,%d): SetCommState() failed (code %d)\n",
			port,rate,bytesize,parity,stopbits,GetLastError());
#endif	/* CHECKED_BUILD */
		CloseHandle(com);
		return NULL;
	}
	PurgeComm(com,PURGE_TXABORT|PURGE_RXABORT|PURGE_TXCLEAR|PURGE_RXCLEAR);
	return (comm_handle_t)comm_port_create(com,port_name);
}

/*
 *	commClose()
 */
void	V_GLOBAL
commClose(comm_handle_t comm)
{
	comm_port_t *com;
	com=(comm_port_t*)comm;
	if(!com || com->magic != COMM_MAGIC)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,
			"commClose(%X): incorrect parameter.\n",comm);
#endif	/* CHECKED_BUILD */
		return;
	}
	CloseHandle(com->port);
	comm_port_destroy(com);
}

/*
 *	commReset()
 */
void	V_GLOBAL
commReset(comm_handle_t comm)
{
	comm_port_t *com;
	com=(comm_port_t*)comm;
	if(!com || com->magic!=COMM_MAGIC)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,
			"commReset(%X): incorrect parameter.\n",comm);
#endif	/* CHECKED_BUILD */
		return;
	}
	SetEvent(com->cancel_io);
	PurgeComm(com->port,
		PURGE_TXABORT|PURGE_RXABORT|PURGE_TXCLEAR|PURGE_RXCLEAR);
}

int		V_GLOBAL
commRead(comm_handle_t comm,void *dst,u32_t num_bytes)
{
	DWORD rd;
	u8_t *ptr;
	comm_port_t *com;
	com=(comm_port_t*)comm;
	if(!com || com->magic!=COMM_MAGIC || !dst || !num_bytes)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,"commRead(%X,%X,%d): incorrect "
			"parameter(s).\n",comm,dst,num_bytes);
#endif	/* CHECKED_BUILD */
		return 0;
	}
	for(rd=0,ptr=(u8_t*)dst;;)
	{
		if(WaitForSingleObject(com->cancel_io,0)==WAIT_OBJECT_0)
		{
#ifdef		CHECKED_BUILD
			conlPrintf(LOG_ERROR,
				"commRead(): reading canceled.\n",
				GetLastError());
#endif		/* CHECKED_BUILD */
			ResetEvent(com->cancel_io);
			return 0;
		}
		if(!ReadFile(com->port,ptr,num_bytes,&rd,NULL))
		{
			int last_err;
			last_err=GetLastError();
#ifdef		CHECKED_BUILD
			conlPrintf(LOG_ERROR,
				"commRead(): ReadFile() failed (code %d).\n",
				last_err);
#endif		/* CHECKED_BUILD */
			return 0;
		}
		num_bytes-=rd;
		ptr+=rd;
		if(num_bytes)
		{
#ifdef		CHECKED_BUILD
			conlPrintf(LOG_TRACE,
				"commRead(): timeout reached; trying again ...\n");
#endif		/* CHECKED_BUILD */
			/*	Sleep some time to give application ability to cancel IO
			 *	operation from another thread; than try again. */
			Sleep(10);
		}
		else
			break;
	}
	return (int)(ptr-(u8_t*)dst);
}

int		V_GLOBAL
commWrite(comm_handle_t comm,void *src,u32_t num_bytes)
{
	DWORD wrote;
	comm_port_t *com;
	com=(comm_port_t*)comm;
	if(!com || com->magic != COMM_MAGIC || !src || !num_bytes)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,"commWrite(%X,%X,%d): incorrect "
			"parameter(s)%s.\n",comm,src,num_bytes);
#endif	/* CHECKED_BUILD */
		return 0;
	}
	WriteFile((HANDLE)comm,src,num_bytes,&wrote,NULL);
	return wrote;
}

#endif	/* 0 */

#elif	defined(__UNIX__)	/* __WIN32__ */
#error	TODO: Implement UNIX COMM I/O.
#elif	defined(__DOS32__)	/* defined(__UNIX__) */
#error	TODO: Implement DOS COMM I/O.
#endif	/* defined(__DOS32__) */

/*</pre></strong></body></html>*/
/*EOF*/
