/*<html><body bgcolor=#000080><font color=#C0C0B0><strong><pre>*/
#include	"../include/v_lib.h"
#include	"../source/v_mt.h"

#ifndef	RIGHT_SLASHED

int	V_LOCAL
os_chdir(char *dir)
{
	char os_dir[_MAX_PATH];
	strCopy(os_dir,dir,_MAX_PATH);
	fsUnix2Dos(os_dir);
	return _chdir(os_dir);
}

int	V_LOCAL
os_mkdir(char *dir)
{
	char os_dir[_MAX_PATH];
	strCopy(os_dir,dir,_MAX_PATH);
	fsUnix2Dos(os_dir);
	return _mkdir(os_dir);
}

#else	/* RIGHT_SLASHED */

#define	os_chdir(path)	chdir(path)
#define	os_mkdir(path)	mkdir(path,S_IRWXU|S_IRWXG|S_IROTH|S_IXOTH)

#endif

/*
 *	Splits full path, creates dir and name+extension
 */
void	V_LOCAL
split_dir_and_name_ext_from_path(char *dir,char *name_ext,char *full_path)
{
	char *end;
	char path[_MAX_PATH];
	int pl;
	strCopy(path,full_path,_MAX_PATH);
	pl=strlen(path);
	if(pl==0)
	{
		if(dir)
			*dir=0;
		if(name_ext)
			*name_ext=0;
		return;
	}
	for(end=path+pl-1;end>path && *end!='/';end--);
	/*	advance pointer to skip last slash.
	 */
	if(*end=='/')
		end++;
	if(name_ext)
		strCopy(name_ext,end,_MAX_FNAME+_MAX_EXT+1);
	/* dir can be NULL */
	if(dir)
	{
		/* split dir */
		end[0]=0;
		strCopy(dir,path,_MAX_DIR);
	}
}

/*
 *	Splits name and extension.
 */
void	V_LOCAL
split_name_and_ext_from_name_ext(char *name,char *_ext,char *name_and_ext)
{
	char *end;
	int ext_len;
	char name_ext[_MAX_FNAME+_MAX_EXT+1];
	char ext[_MAX_EXT];
	strCopy(name_ext,name_and_ext,_MAX_FNAME+_MAX_EXT+1);
	for(end=name_ext+strlen(name_ext)-1;end>name_ext && *end!='.';end--);
	if(end==name_ext)
		ext[0]=0;
	else
		strCopy(ext,end+1,_MAX_EXT);
	if(_ext)
		strcpy(_ext,ext); /* strCopy is not needed */
	if(name)
	{
		ext_len=strlen(ext);
		if(ext_len)
			name_ext[strlen(name_ext)-ext_len-1]=0;
		strCopy(name,name_ext,_MAX_FNAME);
	}
}

/*
 *	Splits path onto pieces.
 */
void	V_GLOBAL
fsSplitPath(char *full_path,char *drive,char *dir,char *name, char *ext)
{
	char name_ext[_MAX_FNAME+_MAX_EXT+1];
	if(!full_path || full_path[0]==0)
    {
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,
			"fsSplitPath('%s'): incorrect parameter.\n",dbs(full_path));
#endif	/* CHECKED_BUILD */
        if(drive)
        	*drive=0;
        if(dir)
        	*dir=0;
        if(name)
        	*name=0;
        if(ext)
        	*ext=0;
		return;
    }
	/* strip drive */
#ifdef	__UNIX__
	/* no drive */
	if(drive)
		drive[0]=0;
#else	/* __UNIX__ */
	/* there are two slashes before drive letter */
	if(strlen(full_path)>=3 && full_path[0]=='/' && full_path[1]=='/')
	{
		if(drive)
		{
			drive[0]=full_path[2];
			drive[1]=0;
		}
#ifdef	CHECKED_BUILD
		if(full_path[3]!='/')
			conlPrintf(LOG_WARNING,
				"fsSplitPath('%s'): directory must start with '/' if "
				"drive specified.\n",full_path);
#endif	/* CHECKED_BUILD */
		full_path+=3;
	}
	else
		if(drive)
			drive[0]=0;
#endif	/* __UNIX__ */
	split_dir_and_name_ext_from_path(dir,name_ext,full_path);
	split_name_and_ext_from_name_ext(name,ext,name_ext);
}

/*
 *	Makes full path from parts (some/all parts can be NULL).
 */
void	V_GLOBAL
fsMakePath(char *dest_path,char *drive,char *dir,char *name, char *ext)
{
	int avail,len;
	char *end;
	if(!dest_path)
    {
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,
			"fsMakePath('%s'): incorrect dest path.\n",dbs(NULL));
#endif	/* CHECKED_BUILD */
		return;
	}
	avail=_MAX_PATH;
	end=dest_path;
	*end=0;
#ifndef	__UNIX__
	if(drive && drive[0])
	{
		end[0]=end[1]='/';
		end[2]=drive[0];
		if(!dir || *dir!='/')
		{
#ifdef	CHECKED_BUILD
			conlPrintf(LOG_WARNING,
				"fsMakePath('%s','%s','%s','%s'): directory must be "
				"absolute if drive specified.\n",dbs(drive),dbs(dir),
				dbs(name),dbs(ext));
#endif	/* CHECKED_BUILD */
			end[3]='/';
			end[4]=0;
			avail--;
			end++;
		}
		else
			end[3]=0;
		avail-=3;
		end+=3;
	}
#endif	/* __UNIX__ */
	if(dir)
	{
		len=strlen(dir);
		if(len)
		{
			strCopy(end,dir,avail);
			avail-=len;
			if(avail<=0)
				return;
			end+=len;
			if(end[-1]!='/')
			{
				*end='/';
				end++;
				*end=0;
				avail--;
			}
		}
	}
	if(name)
	{
		len=strlen(name);
		if(len)
		{
			strCopy(end,name,avail);
			avail-=len;
			if(avail<=0)
				return;
			end+=len;
			if(end[-1]!='.')
			{
				*end='.';
				end++;
				*end=0;
				avail--;
			}
		}
	}
	else
	{
		if(ext && ext[0])
		{
#ifdef	CHECKED_BUILD
			conlPrintf(LOG_WARNING,
				"fsMakePath('%s','%s','%s','%s'): name is empty - "
				"extension ignored.\n",dbs(drive),dbs(dir),
				dbs(name),dbs(ext));
#endif	/* CHECKED_BUILD */
		}
		*end=0;
		return;
	}
	if(ext)
	{
		len=strlen(ext);
		if(len)
			strCopy(end,ext,avail);
	}
}

#ifndef	RIGHT_SLASHED

/*
 *	Converts dos path to unix form
 */
char_p	V_GLOBAL
fsDos2Unix(char *path)
{
	int i;
	char dst_buf[_MAX_PATH];
	char *dst=dst_buf, *orig;
	int max_dest=_MAX_PATH;
	if(!path)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,
			"fsDos2Unix('%s'): incorrect path.\n",dbs(NULL));
#endif	/* CHECKED_BUILD */
		return dbs(NULL);
	}
	orig=path;
	max_dest--;
	if(path[1]==':' && max_dest>2)
	{
		/* drive present */
		dst[0]=dst[1]='/';
		dst[2]=path[0];
		path+=2;
		dst+=3;
		max_dest-=3;
	}
	for(i=0;i<max_dest;i++)
	{
		if(*path=='\\')
			*dst = '/';
		else
			*dst=*path;
		if(!*path)
			break;
		dst++;
		path++;
	}
	*dst=0;
	strCopy(orig,dst_buf,_MAX_PATH);
	return orig;
}

/*
 *	Converts unix path to dos form
 */
char_p	V_GLOBAL
fsUnix2Dos(char *path)
{
	int count;
	char dst_buf[_MAX_PATH];
	char *dst=dst_buf, *orig;
	int max_dest=_MAX_PATH-1;
	if(!path)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,
			"fsUnix2Dos('%s'): incorrect path.\n",dbs(NULL));
#endif	/* CHECKED_BUILD */
		return dbs(NULL);
	}
	orig=path;
	if(path[0]=='/' && path[1]=='/')
	{
		dst[0]=path[2];
		dst[1]=':';
		count=3;
		dst+=2;
		max_dest-=3;
	}
	else
		count=0;
	for(;count<max_dest;count++)
	{
		if(path[count]=='/')
			*dst='\\';
		else
			*dst=path[count];
		dst++;
		if(!path[count])
			break;
	}
	*dst=0;
	strCopy(orig,dst_buf,_MAX_PATH);
	return orig;
}

#else	/* RIGHT_SLASHED */

char_p	V_GLOBAL
fsDos2Unix(char *path)
{
	return dbs(path);
}

char_p	V_GLOBAL
fsUnix2Dos(char *path)
{
	return dbs(path);
}

#endif	/* RIGHT_SLASHED */

#ifndef	HAVE_DIRENT

void	V_GLOBAL
fsScan(
	void (V_CALL *dir_callback)(char*),
	void (V_CALL *file_callback)(char*),
	vboolean recursive)
{
	struct _finddata_t fd;
	long handle, rc;
	char curdir[_MAX_DIR], name[_MAX_PATH];
	char path_delimiter[2]="/";
	if(!dir_callback && !file_callback)
	{
#ifdef	CHECKED_BUILD
		conlPuts(LOG_ERROR,"fsScan(): both callbacks is NULL.\n");
#endif	/* CHECKED_BUILD */
		return;
	}
	_getcwd(curdir,_MAX_DIR);
	fsDos2Unix(curdir);
	/* root */
	if(curdir[strlen(curdir)-1]=='/')
		path_delimiter[0]=0;
	if(dir_callback)
		dir_callback(curdir);
	handle=_findfirst("*.*",&fd);
	rc=handle;
	while(rc!=-1) 
	{
		if(fd.name[0]=='.')
		{
			rc=_findnext(handle,&fd);
			continue;
		}
		if(fd.attrib & _A_SUBDIR)
		{
			if(recursive)
			{
				if(_chdir(fd.name)==0)
				{
					fsScan(dir_callback,file_callback,recursive);
					_chdir("..");
				}
#ifdef			CHECKED_BUILD
				else
				{
					conlPrintf(LOG_ERROR,"fsScan(): can't _chdir(%s).\n",
						fd.name);
				}
#endif			/* CHECKED_BUILD */
			}
			else /* !recursive - call dir callback for every dir */
			{
				if(dir_callback)
				{
					strCopy(name,curdir,_MAX_PATH);
					strCat(name,path_delimiter,_MAX_PATH-strlen(name));
					fsDos2Unix(fd.name);
					strCat(name,fd.name,_MAX_PATH-strlen(name));
					dir_callback(name);
				}
			}
		}
		else
		{
			if(file_callback)
			{
				strCopy(name,curdir,_MAX_PATH);
				strCat(name,path_delimiter,_MAX_PATH-strlen(name));
				strCat(name,fd.name,_MAX_PATH-strlen(name));
				file_callback(name);
			}
		}
		rc=_findnext(handle,&fd);
	}
	_findclose(handle);
}

#else	/* HAVE_DIRENT */

#ifdef	__BORLANDC__

/*
 *	stat() in CBuilder3 is BROKEN, so we must implement another way
 *	to decide whether given name is name of directory.
 *	BUGS: Will not always work correctly on NTFS partitions due
 *	to protection capabilities (i.e. _chdir() may failed if user
 *	have no permissions, and function report than given name
 *	is file name)
 */
int fixed_stat(const char *path, struct stat *statbuf)
{
    int retval;
    retval=stat(path,statbuf);
	if(retval)
    	return retval;
    /*
     *	HACK: try to perform _chdir()
     */
    if(_chdir(path)==0)
    {
        /* We are succedeed - _chdir() back */
    	_chdir("..");
	    statbuf->st_mode = S_IFDIR;
    }
    else
    {
#if		0
		/* may be _chdir() filed if no permissions ? */
		
#endif
		statbuf->st_mode = S_IFREG;
	}
    return retval;
}

#endif	/* __BORLANDC__ */

void	V_GLOBAL
fsScan(
	void (V_CALL *dir_callback)(char*),
	void (V_CALL *file_callback)(char*),
	vboolean recursive)
{
	DIR *dir;
	struct dirent *ent;
	struct stat st;
	char osdir[_MAX_DIR], curdir[_MAX_DIR];
    char fname[_MAX_PATH], uname[_MAX_PATH];
	char path_delimiter[2]={'/',0};
	if(!dir_callback && !file_callback)
	{
#ifdef	CHECKED_BUILD
		conlPuts(LOG_ERROR,"fsScan(): both callbacks is NULL.\n");
#endif	/* CHECKED_BUILD */
		return;
	}
	_getcwd(osdir,_MAX_DIR);
	strCopy(curdir,osdir,_MAX_DIR);
	fsDos2Unix(curdir);
	if(curdir[strlen(curdir)-1]=='/')
		path_delimiter[0]=0;
	if(dir_callback)
		dir_callback(curdir);
	dir = opendir(osdir);
	if(!dir)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,
			"fsScan(): unable to opendir('%s').\n",osdir);
#endif	/* CHECKED_BUILD */
		return;
	}
	while((ent = readdir(dir)) != NULL)
	{
		if(ent->d_name[0]=='.')
			continue;
#ifdef	__BORLANDC__
		fixed_stat(ent->d_name,&st);
#else	/* __BORLANDC__ */
		stat(ent->d_name,&st);
#endif	/* __BORLANDC__ */
		if(st.st_mode & S_IFREG)
		{
			if(file_callback)
			{
				strCopy(fname,curdir,_MAX_PATH);
				strCat(fname,path_delimiter,_MAX_PATH-strlen(fname));
				strCat(fname,ent->d_name,_MAX_PATH-strlen(fname));
				file_callback(fname);
			}
		}
		else if(st.st_mode & S_IFDIR)
		{
			if(recursive)
			{
				if(_chdir(ent->d_name)==0)
				{
					fsScan(dir_callback,file_callback,recursive);
					_chdir("..");
				}
#ifdef			CHECKED_BUILD
				else
				{
					conlPrintf(LOG_ERROR,"fsScan(): can't _chdir('%s').\n",
						ent->d_name);
				}
#endif			/* CHECKED_BUILD */
			}
			else
			{
				if(dir_callback)
				{
					strCopy(uname,curdir,_MAX_PATH);
					strCat(uname,path_delimiter,_MAX_PATH-strlen(uname));
					strCat(uname,ent->d_name,_MAX_PATH-strlen(uname));
					fsDos2Unix(uname);
					dir_callback(uname);
				}
			}
		}
	}
	closedir(dir);
}

#endif	/* HAVE_DIRENT */

/*
 *	Replaces extension in filename
 */
void	V_GLOBAL
fsReplaceExt(char *dst,char *name,char *ext)
{
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_FNAME];
	if(!dst || !name || !ext)
    {
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,
			"fsReplaceExt('%s','%s',%s'): incorrect parameter(s).\n",
			dbs(dst),dbs(name),dbs(ext));
#endif	/* CHECKED_BUILD */
		return;
	}
	fsSplitPath(name,drive,dir,fname,NULL);
	fsMakePath(dst,drive,dir,fname,ext);
}

/*	
 *	Reads PAK's directory and places it in global thread storage
 */
pak_info_p V_LOCAL
fsOpenPak(char *path)
{
	FILE *pakfile;
	pak_info_t *pak;
	char *ospath;
	dpackheader_t head={IDPAKHEADER,0,0};
#ifdef	RIGHT_SLASHED
	ospath=path;
#else	/* RIGHT_SLASHED */
	char buf[_MAX_PATH];
	ospath=buf;
	strCopy(ospath,path,_MAX_PATH);
	fsUnix2Dos(ospath);
#endif	/* RIGHT_SLASHED */
	/* We assume that path is VALID (!=NULL) and already 
	 * converted to OS - dependent form, so fopen() is valid call */
	pakfile=fopen(ospath,"rb");
	if(!pakfile)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_WARNING,
			"fsOpenPak('%s'): can't open\n",ospath);
#endif	/* CHECKED_BUILD */
		return NULL;
	}
	if(fread(&head,sizeof(head),1,pakfile)!=1)
	{
		fclose(pakfile);
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_WARNING,
			"fsOpenPak('%s'): error reading PAK header\n",ospath);
#endif	/* CHECKED_BUILD */
		return NULL;
	}
	if(head.ident!=IDPAKHEADER)
	{
		fclose(pakfile);
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_WARNING,
			"fsOpenPak('%s'): head.ident!=IDPAKHEADER\n",ospath);
#endif	/* CHECKED_BUILD */
		return NULL;
	}
	pak=(pak_info_t*)
		malloc(sizeof(pak_info_t)-sizeof(dpackfile_t)+head.dirlen);
	strCopy(pak->path,path,_MAX_PATH);
	pak->dirofs=head.dirofs;
	pak->numres=head.dirlen/sizeof(dpackfile_t);
	pak->fhandle=pakfile;
	fseek(pakfile,head.dirofs,SEEK_SET);
	if(fread(pak->dir,head.dirlen,1,pakfile)!=1)
	{
		fclose(pakfile);
		free(pak);
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_WARNING,
			"fsOpenPak('%s'): error reading PAK directory.\n",ospath);
#endif	/* CHECKED_BUILD */
		return NULL;
	}
	return pak;
}

/*
 *	Frees PAK's directory
 */
void	V_LOCAL
fsClosePak(pak_info_t *pak)
{
	if(!pak)
		return;
	fclose(pak->fhandle);
	free(pak);
}

/*
 *	fsFindResource - finds given name of resource in PAK file
 */
int		V_LOCAL
fsFindResource(pak_info_t *pak,char *name)
{
	u32_t i;
	for(i=0;i<pak->numres;i++)
		if(!strncmp(pak->dir[i].name,name,56)) return i;
	return -1; /* name not found */
}

void	V_GLOBAL
fsScanPaks(void (V_CALL *pak_callback)(char *pak_name),
	void (V_CALL *file_callback)(char *pak_entry))
{
	thread_data_t *td;
	unsigned pak, file;
	pak_info_t *curp;
	td=GetThreadData();
	if(td->num_pak_files==0)
	{
#ifdef	CHECKED_BUILD
		conlPuts(LOG_WARNING,"fsScanPaks(): no PAK files mounted.\n");
#endif	/* CHECKED_BUILD */
		return;
	}
	for(pak=0;pak<td->num_pak_files;pak++)
	{
		curp=td->pak_files[pak];
		if(pak_callback)
			pak_callback(curp->path);
		if(file_callback)
			for(file=0;file<curp->numres;file++)
				file_callback(curp->dir[file].name);
	}
}

/*
 *	Callback for fsInit
 */
void V_LOCAL V_CALL
fsFindPaksCallback(char *name)
{
	thread_data_t *td;
	char ext[_MAX_EXT];
	td=GetThreadData();
	if(td->num_pak_files==MAX_PAKFILES)
	{
#ifdef	CHECKED_BUILD
		conlPuts(LOG_WARNING,
			"fsFindPaks(): num_pak_files==MAX_PAK_FILES.\n");
#endif	/* CHECKED_BUILD */
		return;
	}
	fsSplitPath(name,NULL,NULL,NULL,ext);
	if(!strcasecmp(ext,"pak"))
	{
		conlPrintf(LOG_INFO,"fsFindPaks(): adding '%s' ...\n",name);
		td->pak_files[td->num_pak_files]=fsOpenPak(name);
		if(td->pak_files[td->num_pak_files])
			td->num_pak_files++;
	}
}

/*
 *	fsInit()
 */
vboolean	V_GLOBAL
fsInit(char *path)
{
	char old_path[_MAX_PATH];
	thread_data_t *td;
	_getcwd(old_path,_MAX_PATH);
	fsDos2Unix(old_path);
	if(path)
	{
		if(os_chdir(path)!=0)
		{
#ifdef	CHECKED_BUILD
			conlPrintf(LOG_ERROR,
				"fsInit(): can't _chdir('%s').\n",path);
#endif	/* CHECKED_BUILD */
			return false;
		}
	}
	td=GetThreadData();
#ifdef	CHECKED_BUILD
	conlPrintf(LOG_INFO,"fsInit(): searching for '*.pak' in '%s'\n",
		(path) ? path : old_path);
#endif	/* CHECKED_BUILD */
	td->num_pak_files=0;
	td->numres=0;
	memset(td->pak_files,0,MAX_PAKFILES*sizeof(pak_info_t*));
	/* increase MAX_OPENFILES - entry 0 reserved for error detection */
	memset(td->reshandles,0,(MAX_OPENFILES+1)*sizeof(resrc_p));
	fsScan(NULL,fsFindPaksCallback,0);
	os_chdir(old_path);
#ifdef	CHECKED_BUILD
	conlPrintf(LOG_INFO,"fsInit(): mounted %d PAK files.\n",
		td->num_pak_files);
#endif	/* CHECKED_BUILD */
	return true;
}

/*
 *	Closes file handle by index.
 */
void	V_GLOBAL
fileClose(file_t file)
{
	thread_data_t *td;
	resrc_p r;
	if(file<=0 || file>MAX_OPENFILES)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,"fileClose(%d): invalid handle.\n",file);
#endif	/* CHECKED_BUILD */
		return;
	}
	td=GetThreadData();
	r=td->reshandles[file];
	if(!r)
		return;
	if(r->fhandle)		/* always true for write-only handles */
		fclose(r->fhandle);
	free(r);
	td->reshandles[file]=NULL;
	td->numres--;
}

/*
 *	Returns size of resource.
 */
int		V_GLOBAL
fileSize(file_t file)
{
	resrc_p r;
	thread_data_t *td;
	if(file<=0 || file>MAX_OPENFILES)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,"fileSize(%d): invalid handle.\n",file);
#endif	/* CHECKED_BUILD */
		return 0;
	}
	td=GetThreadData();
	r=td->reshandles[file];
	if(!r)
		return 0;
	if(r->fhandle)
	{
		int curpos,size;
		curpos=ftell(r->fhandle);
		fseek(r->fhandle,0,SEEK_END);
		size=ftell(r->fhandle);
		fseek(r->fhandle,curpos,SEEK_SET);
		return size;
	}
	return r->send-r->sstart;
}

/*
 *	Returns resource's position.
 */
int		V_GLOBAL
fileTell(file_t file)
{
	thread_data_t *td;
	resrc_p r;
	if(file<=0 || file>MAX_OPENFILES)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,"fileTell(%d): invalid handle.\n",file);
#endif	/* CHECKED_BUILD */
		return 0;
	}
	td=GetThreadData();
	r=td->reshandles[file];
	if(!r)
		return 0;
	if(r->fhandle)
		return ftell(r->fhandle);
	return r->scur-r->sstart;
}

/*
 *	fileEof()
 */
vboolean	V_GLOBAL
fileEof(file_t file)
{
	thread_data_t *td;
	resrc_p r;
	if(file<=0 || file>MAX_OPENFILES)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,"fileEof(%d): invalid handle.\n",file);
#endif	/* CHECKED_BUILD */
		return 1; /* return EOF if invalid handle passed */
	}
	td=GetThreadData();
	r=td->reshandles[file];
	if(!r)
		return 1;
	if(r->fhandle)
		return feof(r->fhandle);
	return r->scur==r->send;
}

/*
 *	fileSeek()
 */
int		V_GLOBAL
fileSeek(file_t file,int offset,int whence)
{
	int sold;
	resrc_p r;
	thread_data_t *td;
	if(file<=0 || file>MAX_OPENFILES)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,"fileSeek(%d): invalid handle.\n",file);
#endif	/* CHECKED_BUILD */
		return 0;
	}
	td=GetThreadData();
	r=td->reshandles[file];
	if(!r)
		return 0;
	if(r->fhandle)
		return fseek(r->fhandle,offset,whence);
	sold=r->scur;
	switch(whence)
    {
	case SEEK_SET:
    	r->scur=r->sstart+offset;
        break;
    case SEEK_CUR:
        r->scur+=offset;
        break;
    case SEEK_END:
        r->scur=r->send+offset;
        break;
    }
    if(r->scur<r->sstart)
    {
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_WARNING,
			"fileSeek(%d,%d,%d): can't seek ahead of start.\n",
			file,offset,whence);
#endif	/* CHECKED_BUILD */
    	r->scur=r->sstart;
    }
    else
		if(r->scur>r->send) 
		{
#ifdef	CHECKED_BUILD
			conlPrintf(LOG_WARNING,
				"fileSeek(%d,%d,%d): can't seek beyond end.\n",
        		file,offset,whence);
#endif	/* CHECKED_BUILD */
			r->scur=r->send;
		}
	return sold;
}

/*
 *	fileRead - OPTIMIZE ME !
 */
int		V_GLOBAL
fileRead(file_t	file,void *buffer,int length)
{
	FILE *fh;
	resrc_p r;
	thread_data_t *td;
	if(!length)
		return 0;
	if(file<=0 || file>MAX_OPENFILES)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,
			"fileRead(%d,%X,%d): incorrect parameter(s).\n",
			file,buffer,length);
#endif	/* CHECKED_BUILD */
		return 0;
	}
	td=GetThreadData();
	r=td->reshandles[file];
	if(!r)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,
			"fileRead(%d,%X,%d): invalid handle '%d'.\n",
			file,buffer,length,file);
#endif	/* CHECKED_BUILD */
		return 0;
	}
	if(r->fhandle)
  		return fread(buffer,1,length,r->fhandle);
	if((r->scur+length)>r->send)
		length=r->send-r->scur;
	fh=td->pak_files[r->paknum]->fhandle;
	fseek(fh,r->scur,SEEK_SET);
	length=fread(buffer,1,length,fh);
	r->scur+=length;
	return length;
}
  
/*
 *	fsShutdown()
 */
void V_GLOBAL fsShutdown()
{
	int i,count;
	thread_data_t *td;
	td=GetThreadData();
	for(i=count=0;i<=MAX_OPENFILES;i++)
		if(td->reshandles[i])
		{
			fileClose(i);
			count++;
		}
	if(count)
    	conlPrintf(LOG_WARNING,
    		"fsShutdown(): found %d opened handles.\n",count);
	for(count=i=0;i<MAX_PAKFILES;i++)
		if(td->pak_files[i])
		{
			fsClosePak(td->pak_files[i]);
			count++;
		}
	conlPrintf(LOG_INFO,"fsShutdown(): unmounted %d PAK files.\n",count);
	td->num_pak_files=0;
	td->numres=0;
	memset(td->pak_files,0,MAX_PAKFILES*sizeof(pak_info_t*));
	memset(td->reshandles,0,(MAX_OPENFILES+1)*sizeof(resrc_p));
}

/*
 *	fileOpenRead returns valid handle or 0 if file not exist.
 */
file_t	V_GLOBAL
fileOpenRead(char *name)
{
	resrc_p res;
	int pos,dirnum;
	int i;
#ifndef	RIGHT_SLASHED
	char dos_path[_MAX_PATH];
#endif	/* RIGHT_SLASHED */
	thread_data_t *td;
	if(!name)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,"fileOpenRead('%s'): incorrect parameter.\n",
			dbs(name));
#endif	/* CHECKED_BUILD */
		return 0;
	}
	td=GetThreadData();
	if(td->numres==MAX_OPENFILES)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,"rfind('%s'): too many resource handles.\n"
			"Increase MAX_OPENFILES in v_paklib.cpp.\n",name);
#endif	/* CHECKED_BUILD */
		return 0;
	}
	res=(resrc_p)malloc(sizeof(resrc_t));
	memset(res,0,sizeof(resrc_t));
	/*	Entry #0 reserved.
	 *	Here we granted that there is al least one free slot for reshandle.
	 */
	for(pos=1;td->reshandles[pos];pos++);
	if(name[0]=='C' && name[1]=='O' && name[2]=='N' && !name[3])
	{
		res->fhandle=stdin;
		td->reshandles[pos]=res;
		td->numres++;
		return (file_t)pos;
	}
	/*	Try to find resource on disk.
	 */
#ifndef	RIGHT_SLASHED
	strCopy(dos_path,name,_MAX_PATH);
	fsUnix2Dos(dos_path);
	res->fhandle=fopen(dos_path,"rb");
#else
	res->fhandle=fopen(name,"rb");
#endif /* */
	if(res->fhandle)
	{
		/* File present - don't search in PAK files. */
		td->reshandles[pos]=res;
		td->numres++;
		return (file_t)pos;
	}
	/* try to find resource in pak files */
	for(i=td->num_pak_files-1;i>=0;i--)
	{
		dirnum=fsFindResource(td->pak_files[i],name);
		if(dirnum!=-1)
		{
			res->dirnum=dirnum;
			td->reshandles[pos]=res;
			res->paknum=i;
			res->sstart=td->pak_files[i]->dir[res->dirnum].filepos;
			res->send=res->sstart+td->pak_files[i]->dir[res->dirnum].filelen;
			res->scur=res->sstart;
			td->numres++;
			return (file_t)pos;
		}
	}
	free(res);
#ifdef	CHECKED_BUILD
	conlPrintf(LOG_WARNING,"fileOpenRead('%s'): not found.\n",name);
#endif	/* CHECKED_BUILD */
	return 0;
}

/*
 *	Returns malloc()'ed buffer.
 */
void_p	V_GLOBAL
fileLoad(char *name,int *len)
{
	int size;
	file_t handle;
	void *buffer;
	handle=fileOpenRead(name);
	if(!handle) /* stay quiet: fileOpenRead() already reported. */
		return NULL;
	size=fileSize(handle);
	buffer=malloc(size+1);	/* useful for parsing */
	if(fileRead(handle,buffer,size)!=size)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,"fileLoad('%s'): can't read %d bytes.\n",
			name,size);
#endif	/* CHECKED_BUILD */
		free(buffer);
		fileClose(handle);
		return NULL;
	}
	if(len)
		*len=size;
	fileClose(handle);
	return buffer;
}

/*
 *	fileOpenWriteOrAppend
 */
file_t	V_LOCAL
fileOpenWriteOrAppend(char *name,vboolean append,vboolean recursive)
{
	resrc_p res;
	int pos;
	thread_data_t *td;
#ifndef	RIGHT_SLASHED
	char dos_path[_MAX_PATH];
#endif	/* RIGHT_SLASHED */
	if(!name)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,
			"fileOpenWriteOrAppend('%s'): incorrect parameter.\n",
			dbs(name));
#endif	/* CHECKED_BUILD */
		return 0;
	}
	td=GetThreadData();
	if(td->numres==MAX_OPENFILES)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,"fileOpenWrite('%s'): too many resource handles.\n"
			"Increase MAX_OPENFILES in 'v_mt.h'.\n",name);
#endif	/* CHECKED_BUILD */
		return 0;
	}
	res=(resrc_p)malloc(sizeof(resrc_t));
	memset(res,0,sizeof(resrc_t));
	/*	Entry #0 reserved.
	 *	Here we granted that there is al least one free slot for handle.
	 */
	for(pos=1;td->reshandles[pos];pos++);
	if(name[0]=='C' && name[1]=='O' && name[2]=='N' && !name[3])
	{
		res->fhandle=stdout;
		td->reshandles[pos]=res;
		td->numres++;
		return pos;
	}
#ifndef	RIGHT_SLASHED
	strCopy(dos_path,name,_MAX_PATH);
	fsUnix2Dos(dos_path);
	if(append)
		res->fhandle=fopen(dos_path,"ab");
	else
		res->fhandle=fopen(dos_path,"wb");
#else
	if(append)
		res->fhandle=fopen(name,"ab");
	else
		res->fhandle=fopen(name,"wb");
#endif /* __WIN32__ */
	if(res->fhandle)
	{
		td->reshandles[pos]=res;
		td->numres++;
		return pos;
	}
	/*
	 *	Can't create file; may be, directory not exists ?
	 */
	if(!recursive) /* is it first pass ? */
	{
		parser_t dp;
		char dest_dir[_MAX_DIR];
		char inc_dir[_MAX_DIR];
		split_dir_and_name_ext_from_path(dest_dir,NULL,name);
		dp=tokStart(dest_dir,"/");
		inc_dir[0]=0;
		while(tokNext(dp))
		{
			strCat(inc_dir,tokLast(dp),_MAX_DIR-strlen(inc_dir));
			if(!strcmp(tokLast(dp),"/"))
				continue;
			if(os_chdir(inc_dir)!=0)
			{
				if(os_mkdir(inc_dir)!=0)
				{
#ifdef	CHECKED_BUILD
					conlPrintf(LOG_ERROR,
						"fileOpenWrite('%s'): can't _mkdir('%s').\n",name,
						inc_dir);
#endif	/* CHECKED_BUILD */
					free(dp);
					return 0;
				}
			}
		} /* while(tokNext(dp)) */
		free(dp);
		/* Directory created: try again */
		return fileOpenWriteOrAppend(name,append,1);
	}
#ifdef	CHECKED_BUILD
	conlPrintf(LOG_ERROR,"fileOpenWrite(%s): can't open.\n",name);
#endif	/* CHECKED_BUILD */
	return 0;
}

file_t	V_GLOBAL
fileOpenWrite(char *name)
{
	return fileOpenWriteOrAppend(name,false,0);
}

file_t	V_GLOBAL
fileOpenAppend(char *name)
{
	return fileOpenWriteOrAppend(name,true,0);
}

/*	Writes to file
 */
int		V_GLOBAL
fileWrite(file_t file,void *buf,int len)
{
	thread_data_t *td;
	resrc_p r;
	if(!len)
		return 0;
	if(file<=0 || file>MAX_OPENFILES)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,"fileWrite(%d): invalid handle.\n",file);
#endif	/* CHECKED_BUILD */
		return 0;
	}
	td=GetThreadData();
	r=td->reshandles[file];
	if(!r)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,
			"fileWrite(%d,%X,%d): invalid handle '%d'.\n",
			file,buf,len,file);
#endif	/* CHECKED_BUILD */
		return 0;
	}
	return fwrite(buf,1,len,r->fhandle);
}

/*
 *	Buffer isn't free()'ed.
 */
vboolean	V_GLOBAL
fileSave(char *name,void *buf,int len)
{
	file_t handle;
	int retval;
	if(!name || !buf || !len)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,
			"fileSave('%s',%X,%d): invalid parameter(s).\n",dbs(name),
				buf,len);
#endif	/* CHECKED_BUILD */
		return false;
	}
	handle=fileOpenWrite(name);
	if(!handle)
		return false;
	retval=fileWrite(handle,buf,len);
	fileClose(handle);
	return (retval==len) ? true : false;
}

char_t V_GLOBAL
fileGetc(file_t file)
{
	char_t val;
	fileRead(file,&val,1);
	return val;
}

vboolean V_GLOBAL
filePutc(file_t file,int c)
{
	return fileWrite(file,&c,1); /* always zero or 1 */
}

vboolean V_GLOBAL
filePuts(file_t file,char *str)
{
	int len, wrlen;
	if(file<=0 || file>MAX_OPENFILES || !str)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,"filePuts(%d,'%s'): invalid parameter(s).\n",
			file,dbs(str));
#endif	/* CHECKED_BUILD */
		return false;
	}
	len=strlen(str);
	wrlen=fileWrite(file,str,len);
	filePutc(file,0x0A);
	return (len==wrlen) ? true : false;
}

/*
 *	TODO: rewrite it, it is VERY slow.
 */
int		V_GLOBAL
fileGets(file_t file,char *buf,int n)
{
	char c;
	char *next;
	if(file<=0 || file>MAX_OPENFILES || !buf || !n)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,
			"fileGets(%d,%X,%d): invalid parameter(s).\n",file,buf,n);
#endif	/* CHECKED_BUILD */
		return 0;
	}
	for(;;)
	{
		c=(char)fileGetc(file);
		if(c!=0x0d && c!=0x0a)
			break;
		else
			/* reached EOF while inside a whitespace */
			if(fileEof(file))
				return 0;
	}
	/* 'c' can be last char in file; we copy it anyway */
	for(next=buf;(next-buf)<n-1;)
	{
		*next=c;
		next++;
		c=(char)fileGetc(file);
		if(c==0x0d || c==0x0a || fileEof(file))
			break;
	}
	*next=0;
	return next-buf;
}

/*
 *	filePrintf
 */
vboolean	V_GLOBAL_VA
filePrintf(file_t file,const char *fmt,...)
{
	va_list marker;
	char *ptr;
	char fmt_buffer[MAX_FORMAT_BUFFER];
	int len, wrlen;
	if(file<=0 || file>MAX_OPENFILES || !fmt)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,
			"filePrintf(%d,'%s',...): invalid parameters.\n",file,
			dbs((char*)fmt));
#endif	/* CHECKED_BUILD */
		return false;
	}
	ptr=fmt_buffer;
	va_start(marker,fmt);
	vsprintf(ptr,fmt,marker);
	va_end(marker);
	len=strlen(ptr);
	wrlen=fileWrite(file,ptr,len);
	return (len==wrlen) ? true : false;
}

/*
 *	Returns word stored in file in little-endian (Intel-like)
 *	order.
 */
u16_t	V_GLOBAL
fileGetLittleShort(file_t f)
{
#ifdef	__INTEL__
	u16_t w;
	fileRead(f,&w,2);
	return w;
#else	/* __INTEL__ */
	u32_t b1, b2;
	b1 = fileGetc(f); /* get low byte */
	b2 = fileGetc(f); /* get hi byte */
	return (u16_t)(((b2<<8) & 0xFF00) | (b1 & 0xFF));
#endif	/* __INTEL__ */
}

/*
 *	Stores word in file in little-endian order.
 */
void	V_GLOBAL
filePutLittleShort(file_t f,u16_t w)
{
#ifdef	__INTEL__
	fileWrite(f,&w,2);
#else	/* __INTEL__ */
	filePutc(f,(u8_t)(w & 0xFF)); /* put low byte */
	filePutc(f,(u8_t)((w >> 8) & 0xFF)); /* put hi byte */
#endif	/* __INTEL__ */
}

/*
 *	Returns double word stored in file in little-endian (Intel-like)
 *	order.
 */
u32_t	V_GLOBAL
fileGetLittleLong(file_t f)
{
#ifdef	__INTEL__
	u32_t dw;
	fileRead(f,&dw,4);
	return dw;
#else	/* __INTEL__ */
	u32_t b1, b2, b3, b4;
	b1 = (u32_t)fileGetc(f);
	b2 = (u32_t)fileGetc(f);
	b3 = (u32_t)fileGetc(f);
	b4 = (u32_t)fileGetc(f);
	return (u32_t)(((b4<<24) & 0xFF000000) | ((b3<<16) & 0xFF0000) | 
		((b2<<8) & 0xFF00) | (b1 & 0xFF));
#endif	/* __INTEL__ */
}

/*
 *	Stores dword in little-endian order.
 */
void	V_GLOBAL
filePutLittleLong(file_t f,u32_t dw)
{
#ifdef	__INTEL__
	fileWrite(f,&dw,4);
#else	/* __INTEL__ */
	filePutc(f,(u8_t)(dw & 0xFF));
	filePutc(f,(u8_t)((dw & 0xFF00) >> 8));
	filePutc(f,(u8_t)((dw & 0xFF0000) >> 16));
	filePutc(f,(u8_t)((dw & 0xFF000000) >> 24));
#endif	/* __INTEL__ */
}

/*</pre></strong></body></html>*/
/*EOF*/
