/*<html><body bgcolor=#000080><font color=#C0C0B0><strong><pre>*/
#include	"../include/v_lib.h"
#include	"../source/v_mt.h"

/*
 *	TODO: change to use vp_stack_t.
 */
 
void V_LOCAL V_CALL
con_file_puts(char *str) 
{ 
	fprintf(GetThreadData()->log_file,"%s",str);
}

void V_LOCAL V_CALL
con_file_puts_and_flush(char *str) 
{ 
	thread_data_t *td=GetThreadData();
	fprintf(td->log_file,"%s",str);
	fflush(td->log_file);
}

void V_LOCAL V_CALL
con_con_puts(char *str)
{
	printf("%s",str);
}

vboolean V_GLOBAL
logAddCallback(con_puts_t outcallback)
{
	int pos;
	con_puts_t *callbacks;
	if(!outcallback)
		return false;
	callbacks=GetThreadData()->log_callbacks;
	for(pos=0;callbacks[pos] && pos<LOG_MAX_DEST;pos++);
		if(pos==LOG_MAX_DEST)
			return false;
	callbacks[pos]=outcallback;
	return true;
}
  
void V_GLOBAL
logRemoveCallback(con_puts_t outcallback)
{
	int pos;
	con_puts_t *callbacks;
	if(!outcallback)
		return;
	callbacks=GetThreadData()->log_callbacks;
	for(pos=0;pos<LOG_MAX_DEST;pos++) 
		if(callbacks[pos]==outcallback)
			callbacks[pos]=NULL;
}

u32_t	V_GLOBAL
logUpperLevel(int level)
{
	u32_t ol;
	u32_t *l;
	l=&(GetThreadData()->log_upper_level);
	ol=*l;
	*l=level;
	return ol;
}

vboolean V_GLOBAL
logStartConsoleLog(void)
{
	return logAddCallback(con_con_puts);
}

void V_GLOBAL
logStopConsoleLog(void)
{
	logRemoveCallback(con_con_puts);
}

vboolean V_GLOBAL
logStartFileLog(char *name,vboolean flush_mode)
{
	int pos;
	thread_data_t *td;
	td=GetThreadData();
	if(!name || td->log_file)
		return false;
	for(pos=0;td->log_callbacks[pos] && pos<LOG_MAX_DEST;pos++);
	if(pos==LOG_MAX_DEST)
		/* not enought place */
		return false;
#ifndef	RIGHT_SLASHED
	{
		char right_name[_MAX_PATH];
		strCopy(right_name,name,_MAX_PATH);
		fsUnix2Dos(right_name);
		td->log_file=fopen(right_name,"at");
	}
#else	/* RIGHT_SLASHED */
	td->log_file=fopen(name,"at");
#endif	/* RIGHT_SLASHED */
	if(td->log_file)
	{
		if(flush_mode)
			td->log_callbacks[pos]=con_file_puts_and_flush;
		else
			td->log_callbacks[pos]=con_file_puts;
		return true;
	}
	/* Unable to open log file */
#ifdef	CHECKED_BUILD
	/* May be some other logs started ? */
	conlPrintf(LOG_ERROR,"logStartFileLog('%s'): unable to open file.\n",
		name);
#endif
	return false;
}

void V_GLOBAL
logStopFileLog(void)
{	
	thread_data_t *td;
	td=GetThreadData();
	logRemoveCallback(con_file_puts_and_flush);
	logRemoveCallback(con_file_puts);
	fclose(td->log_file);
	td->log_file=NULL;
}

void V_GLOBAL
conPuts(char *str)
{
	int pos;
	con_puts_t *callbacks;
	if(!str)
		return;
	callbacks=GetThreadData()->log_callbacks;
	for(pos=0;pos<LOG_MAX_DEST;pos++)
		if(callbacks[pos])
			callbacks[pos](str);
}

char_p	V_GLOBAL_VA
logFormatString(char *dest,const char *fmt, ...)
{
	va_list marker;
	char *ptr;
	if(!fmt)
		return NULL;
	ptr=dest;
	va_start(marker,fmt);
	vsprintf(ptr,fmt,marker);
	va_end(marker);
	return ptr;
}

void V_GLOBAL_VA
conPrintf(const char *fmt, ...)
{
	va_list marker;
	char *ptr;
	char log_fmt_buffer[MAX_FORMAT_BUFFER];
	if(!fmt)
		return;
	ptr=log_fmt_buffer;
	va_start(marker,fmt);
	vsprintf((char*)ptr,fmt,marker);
	va_end(marker);
	conPuts(ptr);
}

void	V_GLOBAL
conlPuts(u32_t level,char *str)
{
	int pos;
	con_puts_t *callbacks;
	thread_data_t *td;
	td=GetThreadData();
	if(level>td->log_upper_level || !str)
		return;
	callbacks=GetThreadData()->log_callbacks;
	for(pos=0;pos<LOG_MAX_DEST;pos++)
		if(callbacks[pos])
			callbacks[pos](str);
}

void	V_GLOBAL_VA
conlPrintf(u32_t level,const char *fmt, ...)
{
	va_list marker;
	char *ptr;
	thread_data_t *td;
	char log_fmt_buffer[MAX_FORMAT_BUFFER];
	td=GetThreadData();
	if(level>td->log_upper_level || !fmt)
		return;
	ptr=log_fmt_buffer;
	va_start(marker,fmt);
	vsprintf(ptr,fmt,marker);
	va_end(marker);
	conPuts(ptr);
}

/*
**	Reads string from console.
*/
vboolean	V_GLOBAL
conGets(char *dest,u32_t dest_len,char *prompt)
{
	if(!dest || !dest_len)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,
			"conGets(%X,%d,%s): incorrect parameter(s).\n",
			dest,dest_len,dbs(prompt));
#endif	/* CHECKED_BUILD */
		return false;
	}
	if(prompt)
		printf(prompt);
	fgets(dest,dest_len,stdin);
	return *dest && *dest!=0x0D && *dest==0x0A;
}

/*
**	Reads integer from console.
*/
vboolean	V_GLOBAL
conGetInt(int *dest,char *prompt)
{
	char buf[128];
	char *endptr;
	if(!dest)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,
			"conGetInt(%X,%s): incorrect 'dest' parameter.\n",
			dest,dbs(prompt));
#endif	/* CHECKED_BUILD */
		return false;
	}
	for(;;)
	{
		if(prompt)
			printf(prompt);
		fgets(buf,128,stdin);
		*dest=strtol(buf,&endptr,0);
		if(!*endptr || *endptr==0x0D || *endptr==0x0A)
			break;
		if(buf[0]!='0')
			puts("Please, enter correct integer number !");
		else
		{
			if(buf[1]!='x' && buf[1]!='X')
				puts("Incorrect octal number.");
			else
				puts("Incorrect hexadecimal number.");
		}
	}
	return endptr > buf;
}

/*
**	Reads floating-point number from console.
*/
vboolean	V_GLOBAL
conGetFloat(mvec_t *dest,char *prompt)
{
	char buf[128];
	char *endptr;
	if(!dest)
	{
#ifdef	CHECKED_BUILD
		conlPrintf(LOG_ERROR,
			"conGetFloat(%X,%s): incorrect 'dest' parameter.\n",
			dest,dbs(prompt));
#endif	/* CHECKED_BUILD */
		return false;
	}
	for(;;)
	{
		if(prompt)
			printf(prompt);
		fgets(buf,128,stdin);
		*dest=(mvec_t)strtod(buf,&endptr);
		if(!*endptr || *endptr==0x0D || *endptr==0x0A)
			break;
		puts("Please, enter correct floating-point number !");
	}
	return endptr > buf;
}

/*</pre></strong></body></html>*/
/*EOF*/
