/*<html><body bgcolor=#000080><font color=#C0C0B0><strong><pre>*/
#ifndef   V_MT_H
#define   V_MT_H

/*	======================================================================
 *	Here are private declarations which are needed only for libv itself.
 *	======================================================================
 */

#ifdef	RIGHT_SLASHED
#define	PATH_DELIMITER				'/'
#else	/* !RIGHT_SLASHED */
#define	PATH_DELIMITER				'\\'
#endif	/* !RIGHT_SLASHED */

/*
 *	TODO: move most data into guarded section.
 */
typedef struct libv_global_data_s
{
	u32_t thread_count;
}	libv_global_data_t, *libv_global_data_p;

/*	From v_log.cpp:
 */
#define	LOG_MAX_DEST				4

/*	From v_paklib.cpp:
 */
#define	MAX_PAKFILES				16
#define	MAX_FILES_IN_PACK			4096
/*	Actual size of rhandles storage is MAX_OPENFILES+1 because entry #0
 *	is reserved for error detection.
 */
#define	MAX_OPENFILES				127
#define	IDPAKHEADER					(('K'<<24)+('C'<<16)+('A'<<8)+'P')

typedef struct
{
	char	name[56];
	i32_t	filepos, filelen;
}	dpackfile_t, *dpackfile_p;

typedef struct
{
	u32_t		ident;
	u32_t		dirofs;
	u32_t		dirlen;
}	dpackheader_t, *dpackheader_p;

typedef struct pak_info_s
{
	char		path[_MAX_PATH];
	u32_t		dirofs,numres;
	FILE		*fhandle;	/* returned by fopen */
	dpackfile_t	dir[1];
}	pak_info_t, *pak_info_p;

typedef struct resrc_s
{
	/* Number of resource in PAK directory */
	u32_t		dirnum;
	/* Number of PAK file */
	u32_t		paknum;
	/* Offset of start of resource in PAK */
	u32_t		sstart;
	/* Offset of last byte of resource + 1 in PAK */
	u32_t		send;
	/* Current offset in PAK */
	u32_t		scur;
	/* Handle of disk file */
	FILE		*fhandle;
}	resrc_t, *resrc_p;

/*
 *	LibV internal TSD.
 */
#define			LIBV_TSD_MAGIC		0x4C696256   /* LibV */

typedef struct	thread_data_s
{
	u32_t		magic;
	/* v_image.c */
	u8_t		constant_alpha;
	/* v_wmf.c */
	u32_t		meta_x_extent,meta_y_extent;
	/* v_log.c */
	FILE		*log_file;
	u32_t		log_upper_level;
	void		(V_CALL *log_callbacks[LOG_MAX_DEST])(char *str);
	/* v_fs.c */
	u32_t		num_pak_files;
	pak_info_t	*pak_files[MAX_PAKFILES];
	i32_t		numres;
	resrc_p		reshandles[MAX_OPENFILES+1];
	/* v_gl.c */
	void		*gl_context;
	vboolean	lower_case;
	vboolean	caps_lock;
	vboolean	num_lock;
	/* v_incon.c */
	u32_t		con_prev_mouse_flags;
}	thread_data_t, *thread_data_p;

#ifndef MULTITHREADED
extern  thread_data_t			__thread_data;
#define GetThreadData()			(&__thread_data)
#else	/* MULTITHREADED */
#define GetThreadData()			((thread_data_t*)(libvGetSpecific()))
#endif	/* MULTITHREADED */

/*
 *		Default constructor
 */
#define	ALLOC_OBJECT(dest,type,extra_memory,magic)\
		dest=(type*)memAlloc(sizeof(type)+extra_memory);\
		memZero((void*)dest,sizeof(type)+extra_memory);\
		MARK_OBJECT(dest,magic);

#ifdef	CHECKED_BUILD
#define	MARK_OBJECT(object,magic)	*((u32_t*)(object))=(u32_t)(magic)
#else	/* !CHECKED_BUILD */
#define	MARK_OBJECT(object,magic)
#endif	/* !CHECKED_BUILD */

/*
 *	Local OS - independent defines.
 */

/*	Vertex drawing function */
typedef	void (*vertex_draw_proc_t)(vec_t *v,vec_t *c,vec_t *n,vec_t *t);
/*	Triangle drawing function */
typedef	void (*tri_draw_proc_t)(tlist_face_t *tri);
/*	Draw flags */
#define	NORMAL_DRAW_BIT			1
#define	TEXTURE_DRAW_BIT		2
#define	COLOR_DRAW_BIT			4

/*
 *	Local OS - independent prototypes.
 */
#ifdef	__cplusplus
extern "C" {
#endif	/* __cplusplus */
	/*
	**	Changing contents of private TSD, used for internal TSD
	**	managing. LibV clients SHOULDN'T call these functions !
	**
	**	Implemented in v_sched.c
	*/
	void		V_CALL			libvSetSpecific(void_p specific);
	void_p		V_CALL			libvGetSpecific(void);
	/*
	**	Returns contents of guarded section. After use, section
	**	MUST be unlocked by libvUnlockGlobal().
	**	Implemented in v_sched.c
	*/
	libv_global_data_p	V_CALL	libvLockGlobal(void);
	/*
	**	Unlocks global data, makes it possible to use by another threads.
	**	Implemented in v_sched.c
	*/
	void	V_CALL	libvUnlockGlobal(void);
	/*
	**	General - purpose function for testing valididy of object's
	**	handles. Returns NULL (and complains an error) if:
	**		a)	agrument is NULL;
	**		b)	(when CHECKED_BUILD) first DWORD of memory pointed
	**			by 'handle' != magic.
	**	Otherwise returns 'handle' back.
	**	Implemented in v_mt.c.
	*/
#ifdef	CHECKED_BUILD
	void_p	V_CALL	libvIsHandle(void *handle,
		char *caller,	/* Name of function handle passed to */
		char *object,	/* Sence of handle: file, ipc, etc... */
		u32_t magic);	/* Magic: must be in FIRST DWORD of object */
#else	/* !CHECKED_BUILD */
#define		libvIsHandle(handle,caller,object,magic)	(handle)
#endif	/* CHECKED_BUILD */
	/*
	**	GL draw procs: returns functions for vertex/triangle drawing
	**	via OpenGL, depending on current OpenGL state.
	*/
	u32_t	/* returns "draw mask", which reflects current GL state */
			V_CALL	vglGetDrawBits(void);
	vertex_draw_proc_t	/* returns proc for vertex drawing */
			V_CALL	vglGetVertexDrawProc(int draw_bits);
	tri_draw_proc_t		/* same as above, for triangles */
			V_CALL		vglGetTriangleDrawProc(int draw_bits);
#ifdef	__cplusplus
}
#endif	/* __cplusplus */

/*
 *	Platform - dependent functions, used internally.
 */
#ifdef	__cplusplus
extern "C" {
#endif	/* __cplusplus */
#ifdef	__WIN32__
	/*				WE ALWAYS WILL LOVE WINDOWS 95 !!! 				*/
	/*	Returns false if we are under NT, otherwise returns true.	*/
	vboolean	V_CALL	WeAreUnderMustDie(void);
#endif	/* __WIN32__ */
#ifdef	__cplusplus
}
#endif	/* __cplusplus */

#endif	/* V_MT_H */

/*</pre></strong></body></html>*/
/*EOF*/
