/*<html><body bgcolor=#000080><font color=#C0C0B0><strong><pre>*/
#include	"../include/v_lib.h"
#include	"../source/v_mt.h"
#include	"v_os.h"

#ifdef		__WIN32__

#define		delay_execution(milliseconds)		Sleep(milliseconds)
#define		get_tick_count						GetTickCount

#elif		defined __UNIX__	/* !__WIN32__ */

#define		delay_execution(milliseconds)		usleep(1000*milliseconds)

u32_t	V_LOCAL
get_tick_count(void)
{
	struct timezone tz={0,0};
	struct timeval tv;
	gettimeofday((struct timeval*)&tv,&tz);
	return tv.tv_sec * 1000 + tv.tv_usec;
}

#elif	defined(__DOS32__)	/* !__UNIX__ */

unsigned	V_LOCAL
get_tick_count(void)
{
#if		CLOCKS_PER_SEC==100		/* WATCOM C */
	return clock() * 10;
#elif	CLOCKS_PER_SEC==1000
	return clock();
#else
	return (unsigned)((double)1000.0*clock()/(double)CLOCKS_PER_SEC);
#endif
}

void	V_LOCAL
delay_execution(unsigned milliseconds)
{
#if	defined(__WATCOMC__)
	/* WATCOM C provides delay() in i86.h */
	delay(milliseconds);
#else
	int seconds, clk, ms;
	seconds = (int)(milliseconds / 1000);
	ms = (int)(milliseconds - seconds * 1000);
	sleep(seconds);
	clk=clock();
	/* I'll implement some sort of sheduler, I promise ... */
	/* DON'T LOOK HERE !!! */
	while((clock()-clk)<ms);
#endif
}

#endif	/* !__DOS32__ */

u32_t	V_GLOBAL
timeTickCount()
{
	return get_tick_count();
}

void	V_GLOBAL
timeDelay(u32_t Milliseconds)
{
	delay_execution(Milliseconds);
}

/*
 *	Sets timer to active state.
 */
void	V_GLOBAL
timerStart(timer_t *timer)
{
#ifdef	CHECKED_BUILD
	if(!timer)
	{
		conlPrintf(LOG_ERROR,"timerStart(NULL): invalid handle.\n");
		return;
	}
#endif	/* CHECKED_BUILD */
	timer->active=true;
	timer->time_start=get_tick_count();
}

/*
 *	Sets timer to passive state: subsequent calls of timerMilliseconds()
 *	return time at the moment of this call.
 */	
void	V_GLOBAL
timerStop(timer_t *timer)
{
#ifdef	CHECKED_BUILD
	if(!timer)
	{
		conlPrintf(LOG_ERROR,"timerStop(NULL): invalid handle.\n");
		return;
	}
#endif	/* CHECKED_BUILD */
	timer->active=false;
	timer->time_start=get_tick_count();
}

u32_t	V_GLOBAL
timerMilliseconds(timer_t *timer)
{
#ifdef	CHECKED_BUILD
	if(!timer)
	{
		conlPrintf(LOG_ERROR,"timerMilliseconds(NULL): invalid handle.\n");
		return 0;
	}
#endif	/* CHECKED_BUILD */
	if(timer->active)
		return get_tick_count() - timer->time_start;
	else
		return timer->time_start;
}

void	V_GLOBAL
timerWait(timer_t *timer,u32_t return_time)
{
	u32_t delay_time=return_time-timerMilliseconds(timer);
	delay_execution(delay_time);
}

/*</pre></strong></body></html>*/
/*EOF*/
