void	V_LOCAL
compute_linear_transform(vec2_t transform,vec2_t in_range,vec2_t out_range)
{
	vec_t in_len=in_range[1]-in_range[0];
	vec_t out_len=out_range[1]-out_range[0];
	if(IsZero(in_len))
		vec2Set(transform,1,0);
	else
	{
		transform[0]=out_len;
		transform[1]=in_range[0]*out_range[1]-in_range[1]*out_range[0];
		vec2Scale(transform,transform,1/in_len);
	}
}

/*
 *	Computes linear transform which produces out_mins from in_mins and
 *	out_maxs from in_maxs.
 */
void	V_LOCAL
compute_linear_transform_3d(vec3_t out_scale,vec3_t out_translate,
	vec3_t in_mins,vec3_t in_maxs,vec3_t out_mins,vec3_t out_maxs)
{
	u32_t i;
	vec2_t in_range, out_range, dest;
	for(i=0;i<3;i++)
	{
		vec2Set(in_range,in_mins[i],in_maxs[i]);
		vec2Set(out_range,out_mins[i],out_maxs[i]);
		compute_linear_transform(dest,in_range,out_range);
		out_scale[i]=dest[0];
		out_translate[i]=dest[1];
	}
}

typedef struct	surface_plot_s
{
	/* surface itself */
	tripatch_t	*surf;
	trilist_t	*tris;
	/* bounging box */
	vec3_t		surf_mins;
	vec3_t		surf_maxs;
	/* pivot point and orientation */
	vec3_t		pivot, dir, up;
	/* grid offsets and spacings */
	vec3_t		grid_offset;
	vec3_t		grid_spacing;
	/* font for labels */
	/* font mode: constant scale or constant FOV - stored inside fonts */
	gl_outline_font_t	*label_fnt[3];
}	surface_plot_t, *surface_plot_p;

/*
void	V_GLOBAL
vglDrawSurfacePlot(surface_plot_t *sp)
{
	tlistDraw ..
}
*/

