#ifndef V_STR_H
#define V_STR_H

class string_c
{
private:
      array_tt<char>  sz;
public:
              string_c() {sz.add(0);}
              ~string_c() {}
              string_c(char *str) 
              {
                while(*str) sz.add(*str++);
                sz.add(0);
              }
              string_c(string_c &ref) 
              {
                sz.concat(ref.sz);
              }
  char        *c_str()  {return (char*)sz.buf;}
  int         len()     {return sz.count()-1;}
  string_c    &cpy(char *str)
              {
                sz.clear();
                while(*str) sz.add(*str++);
                sz.add(0);
                return *this;
              }
  string_c    &cpy(string_c &ref) 
              {
                sz.clear();
                sz.concat(ref.sz);
                return *this;
              }
  string_c    &cat(char *str)
              {
                // removing \0 (I know, this code looks ugly ...)
                if(sz.next_elem) sz.next_elem--;
                while(*str) sz.add(*str++);
                sz.add(0);
                return *this;
              }
  string_c    &cat(string_c &ref)
              {
                if(sz.next_elem) sz.next_elem--;
                sz.concat(ref.sz);
                return *this;
              }
  int         cmp(char *str)            {return strcmp(sz.buf,str);}
  int         ncmp(char *str,int n)     {return strncmp(sz.buf,str,n);}
  int         cmp(string_c &ref)        {return strcmp(sz.buf,ref.sz.buf);}
  int         ncmp(string_c &ref,int n) {return strncmp(sz.buf,ref.sz.buf,n);}
  string_c    &fmt(const char *_fmt,...)
              {
                char dest[1024];
                va_list marker;
                va_start(marker, _fmt);
                vsprintf(dest, _fmt, marker);
                va_end(marker);
                return cpy(dest);
              }
};

class         stringlist_c
{
private:
  array_tt<string_c*> strings;
public:
              stringlist_c() {};
              ~stringlist_c() {clear();}
  void        add(char *str)
              {
                strings.add(new string_c);
                strings[strings.count()-1]->cpy(str);
              }
  void        add(string_c &ref)
              {
                strings.add(new string_c);
                strings[strings.count()-1]->cpy(ref);
              }
  void        clear()
              {
                for(int i=0;i<strings.count();i++)
                  delete strings[i];
                strings.clear();
              }
  int         count() {return strings.count();}
  string_c    &operator[](int index) {return *strings[index];}
};

#endif
